;// sample procedure for PV-WAVE ( with dbstore )
;// 				Copylight 2002.2 NIFS-LABCOM
;// 				Copylight 2007.4 NIFS-LABCOM
;//
;// Author: M.Yoshida
;//
;// Modification Histories
;// 2002/02/26 Create(M.Yoshida)
;// 2007/04/23 S.imazu
;//

;//
PRO dbssample, MailAddress,DiagName, ShotNumber, SubShotNumber, DataType, code
	;// 
	dbsOpen, des ,MailAddress,DiagName, ShotNumber, SubShotNumber, DataType, result


	if 0 EQ result then begin
		;// data read
		DataSize = long(262144)
		pDataArr  = INTARR(DataSize/2)
		for ch = 1, 3 Do BEGIN
			;// read file
			Openr, 1, 'D:\\LHD-Das.5\\' + strtrim(STRING(ShotNumber),2) + '-' + strtrim(STRING(SubShotNumber),2) + '-' + strtrim(STRING(ch),2) + '.dat', Error=err
			if( err ne 0 ) then begin
				print, !Err_String
				return
			endif
			Readu, 1, pDataArr
			Close, 1

			;// parameter set
			ChannelParamSet, pStrArr, result
			if 0 NE result then begin
				GOTO, CHANNELERROR
			endif
			;// channel write
			dbsWrite, des,ch,pStrArr, pDataArr, 'INT16',result
			if 0 NE result then begin
				dbsAbort ,des
				GOTO, CHANNELERROR
			endif
		endfor

		dbsClose, des ,result

	endif

CHANNELERROR:

	code = result
	return
END

PRO ChannelParamSet, pStrArr, code

	result = 0

	initParam , pStrArr ,12
	;// parameter set
	SetParam, pStrArr, 'Range', 5.0, 'FLOAT', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'RangeFactor', 1, 'INTEGER', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'RangePolarity', 'Bipolar', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'ClockSpeed', 10000, 'INTEGER', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'ExtIntClock', 'Internal', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'Mode', 'Aurora12/PTS', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'ClockOutputControl', 'Continous', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'InPolarityStop', 'Pos.', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'InPolarityStart', 'Pos.', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'InPolarityClock', 'Pos.', 'STRING', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'pTS', 0, 'INTEGER', result
	if 0 NE result then goto ,PARAMSET_ERROR
	SetParam, pStrArr, 'MemorySize', 131072, 'INTEGER', result

PARAMSET_ERROR:
	code = result
	return
END
