;// 実時間データ取得プロトコルV2対応  (Obsoleted 2020-05)
;// リアルタイムデータ転送  表示プロシージャ
;//						NIFS LABCOM
;// 使用法は
;//	TVMonitor,'計測名',チャネル番号,mode='...'
;//
;// UPDATE 2020-05
;// IDL55/winではfirewallを無効にする必要がある。　idlde.exeへの受信許可だけでは、NGだった。
;// GDL/winではgdl.exeへの受信許可が必要である。
;//
;// エラーメッセージ表示ルーチン
PRO printerrormessage,errorcode
	CASE errorcode OF
		0	:	print, 'No Error'
		1	:	print, 'Error : Diag Name Not Found'
		2	:	print, 'Error : Channel Number Over Range'
		3	:	print, 'Error : Connect to Index Server Failed'
		4	:	print, 'Error : INDEXSERVERNAME Not Defined'
		5	:	print, 'Error : Error in SQL statement'
		6	:	print, 'Error : Server IP Address Not Found'
		7	:	print, 'Error : Connect to RT Server Failed'
		8	:	print, 'Error : Error in Sending Command'
		9	:	print, 'Error : Error in Receiving Reply'
		10	:	print, 'Error : Already Closed Connection'
		11	:	print, 'Error : Error in Receiveing Data'
		12	:	print, 'Error : Invalid Socket'
		13	:	print, 'Error : Error in Making Scoket'
		14	:	print, 'Error : Time Out'
		15	:	print, 'Error : Wrong Paramter Number'
		16	:	print, 'Error : Not Wave Data Channel'
		17	:	print, 'Error : Not Image Data Channel'

;// RTTransdからのエラーメッセージ
		200	:	print, 'Error : Illegal Command (Please Contact to LABCOM)'
		201	:	print, 'Error : Wrong Channel Number'
		202	:	print, 'Error : Wrong Packet Size'
		203	:	print, 'Error : Wrong Thinning Rate'
		204	:	print, 'Error : Send Command to Unopened Service'
		205	:	print, 'Error : Send Open Command Repeatly'
		206	:	print, 'Error : Shared data on server is unusual. Please wait and retry.'
		207	:	print, 'Error : Send Stop Command Repeatly'
		208	:	print, 'Error : Send Start Command Repeatly'
		209	:	print, 'Error : Connection Refused by Limit'

		ELSE :	print, 'Error : code = ', errorcode
	ENDCASE
END

;//	波形用プロシージャ別名
PRO	WaveMonitor,diagName,channelNumber,udp,nsum=nsums,thinning=thinnings,host=dashost
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		RTRetrieve
	endif
	if( n_params(0) eq 2) then begin
		udp = 0
	endif
	if (KEYWORD_SET(nsums)) then begin
		ns = nsums
	endif else begin
		ns = 1
	endelse
	if (KEYWORD_SET(thinnings)) then begin
		thin = long(thinnings)
	endif else begin
		thin = long(1)
	endelse
	RTRetrieve,diagName,fix(channelNumber),long(udp),nsum=ns,thinning=thin,host=dashost
END

PRO	RTRetrieve,diagName,channelNumber,udp,nsum=nsums,thinning=thinnings,host=dashost
	usage = 0
	if( KEYWORD_SET(dashost) ) then begin
		ttype = size(dashost)
		if( 7 ne ttype(1) ) then begin
			usage = 1
		endif
	endif
	
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		usage = 1
	endif

	if( 1 eq usage ) then begin
		print, 'Usage:'

		print, '  WaveMonitor,diagName,channelNumber[,UDPportNumber][,nsum=N][,thinning=N][,host=HostName]'

		print, ' '
		print, 'Input Parameters:'
		print, '  < diagName      - Diagnostics name'
		print, '  < channelNumber - Channel number'
		print, '  < UDPportNumber - UDP port number'
		print, '  < nsum=N        - plot average of N samples'
		print, '  < thinning=T    - set transfer thinning rate to 1/T'
		print, '  < host=HostName - Host name (''DAS15'',.., etc.)'
		
		retall
	endif
	
	if( n_params(0) eq 2) then begin
		udp = 0
	endif
	
	ns = 1
	if( KEYWORD_SET(nsums) ) then begin
		ns = nsums
	endif

	quit='p'
	is_gdl=1;
	if( -1 EQ strpos(strupcase(!DIR),'GDL') ) then is_gdl=0
	print,'Terminate when "q" or "Q" is entered.'

	;//	DLLのある場所を指定
	if( !version.memory_bits eq 64 ) then object = !Retrieve + '/bin64/RTTransClientDLL.dll' $
	else object = !Retrieve + '/bin/RTTransClientDLL.dll'

	;//	それぞれのDLL関数名を指定
	symbol_Start	= 'IdlLRTStart'
	symbol_End		= 'IdlLRTEnd'
	symbol_Open		= 'IdlLRTOpen'
	symbol_Close	= 'IdlLRTClose'
	symbol_SetInf	= 'IdlLRTSetInf'
	symbol_GetParam = 'IdlLRTGetChannelParam'
	symbol_GetData	= 'IdlLRTGetChannelData'
	symbol_GetChParam = 'IdlLRTGetChParam'

	;//	通信のために使用するハンドル用配列を作成
	;//	充分なサイズがあれば、どのような配列でも可
	;//	この配列の中身についてはDLL内で使用するが、PV-Wave側からでは
	;//	意味の無い値になります
	hnd = intarr(64)

	;//	DLL関数にアクセスし、値を取得したい変数の領域確保
	status = long(0)
	samplingInterval = long(0)
	valueLen = 0
	recLen = long(0)
	packetSize = long(0)


	;//	サーバへの接続開始要求
	result = call_external( object, symbol_Start)
	if (result ne 0) then begin
		printerrormessage, result
		retall
	endif

	;//	計測名、チャネル番号などを指定し、データ受信用ハンドルを取得
	if( KEYWORD_SET(dashost) ) then begin
		result = call_external( object, symbol_Open,$
						diagName, channelNumber, thinnings, hnd, udp, packetSize,$
						dashost, VALUE=[1,0,0,0,0,0,1])
	endif else begin
		result = call_external( object, symbol_Open,$
						diagName, channelNumber, thinnings, hnd, udp, packetSize,VALUE=[1,0,0,0,0,0])
	endelse
	if (result ne 0) then begin
		printerrormessage, result
		retall
	endif

	;//	通信パラメータを取得
	result = call_external( object, symbol_GetParam,$
						hnd, status, samplingInterval, valueLen, recLen, packetSize)
	if (result ne 0) then GOTO, ABORT_RT

	;//	間引き率を指定
	;//	IdlLRTOpen を呼び出すときに指定した間引き率に変更がなければ
	;//	この処理は省くことができます
	result = call_external( object, symbol_SetInf,$
						hnd, thinnings)
	if (result ne 0) then GOTO, ABORT_RT
	
	imageType = bytarr(256)
	result = call_external( object, symbol_GetChParam,$
						hnd, 'ImageType', imageType,VALUE=[0,1,0])
	if (result ne 0) then GOTO, ABORT_RT
	
	sImageType = string(imageType)
	if( sImageType eq 'IllegalParameterName' ) then begin
		print,'Format is unkown(valueLen:' + string(valueLen,format='(I2)') + ').'
		sImageType=''
	endif else begin
		print,'Format is '+ sImageType +'(valueLen:' + string(valueLen,format='(I2)') + ').';
	endelse
	;//	表示するための配列を作成
	;//	当サンプル内ではプロットする点数を指定
	;//	下限として5000を与える
	pointnum = 5000
	;//	データ受信用バッファ作成
	;//	IdlLRTGetChannelParam を呼ぶときに、recLen にはデータパケット１つ
	;//	あたりに含まれるサンプリングデータの個数を取得しています
	if (valueLen le 8) then begin
		bytePerSample = 1
		ttype = 1; BYTE
	endif else if (valueLen le 16) then begin
		bytePerSample = 2
		ttype = 2;	INT(SHORT)
	endif else if (valueLen le 32) then begin
		bytePerSample = 4
		if( 'FLT32' eq sImageType ) then begin
			ttype = 4; FLOAT
		endif else begin
			ttype = 3; LONG(32bit-Int)
		endelse
	endif else if (valueLen le 64) then begin
		bytePerSample = 8
		if( 'FLT64' eq sImageType ) then begin
			ttype = 5; DOUBLE
		endif else begin
			ttype = 14; LON64(IDL, NOT pv-wave)
		endelse
	endif
	
	buflength = recLen/bytePerSample
	if (buflength gt 2500) then begin
		pointnum = buflength * 2
	endif
	buf      = make_array(buflength, type=ttype)
	plotdata = make_array(pointnum,  type=ttype)

	window, 1
	wshow, 1, 1

	prehead=long(0)
	;//	データ受信する際に、ショット番号などを受け取るための領域確保
	shot = long(0);
	subshot = long(0);

	;//	ブロック番号は1から始まり、サーバから次のブロックが
	;//	送られてくるごとにシーケンシャルに増えていきます
	blk = long(0);
	preblk = long(-1);

	;//	受信したブロック中の先頭と最終サンプリングデータが
	;//	収集データ中で何番目にあたるかを示します
	head = 0LL;
	tail = 0LL;

	;//	送られてきたブロックのサイズ
	blen = long(10);

	;//	データ受信のためのループ 
	;//for loopn=1, 10000 do begin
	repeat begin

		;//	データ受信関数を呼び出す
		result = call_external( object, symbol_GetData, hnd, status, shot, subshot, blk, head, tail, buf, blen)

		;//	ブロックのバイト長から、バッファ長を計算
		;//	このサンプル内では、1サンプリングあたり2バイトと決めうちしています
		buflen = blen / bytePerSample

		;//	status は -1, 3, 5, 8 が返ってくる可能性があります
		;//	-1 は意味のあるデータ無しで、他の変数にも無意味な値が入っていますので
		;//	処理なく破棄します
		;//	プラズマデータ収集開始前はほぼすべて -1 になり、
		;//	またデータ収集中でもデータ生成待ちのときには -1 が返ってきます

		;//	3, 5 はサーバがそれぞれモジュールセットアップと初期化を行ったときに返ってきます
		;//	ショット番号、サブショット番号には有効な値が入っていますので
		;//	必要な処理があれば利用できます
		;//	このサンプルでは何も処理していません

		;//	8 はプラズマ計測中にデータが送られてきたときに返ってきます
		;//	他の変数にもそれぞれ有効な値が入り、
		;// 指定したバッファには受信したデータが入ります

		;//	データを受信した際の処理
		;//	このサンプルでは、エラー処理を考えず、受け取ったバッファを
		;//	次々にプロット用の配列に入れていき、スクロールさせながら
		;//	表示するようになっています
		;//	実際にはパケット取りこぼした際などのため、ブロック番号、head,tail など
		;//	を用いて取りこぼしたデータは飛ばして表示するほうが正しいものとなります
		if status NE 8 then begin
			prehead = 0
			preblk = 0
		endif
		if ( status EQ 8 ) AND ( buflen GT 0 )then begin
			if preblk LT blk then begin
				; scroll
				sx = buflen
				plotdata(0 : pointnum - sx - 1) = plotdata(sx : pointnum - 1)

				; new data
				plotdata(pointnum - buflen : pointnum - 1) = buf(0 : buflen - 1)

				plot, plotdata, nsum = ns
				wait, 0.01
				
				prehead = head
				preblk = blk
			endif
		endif
		if( 0 EQ is_gdl ) then quit = GET_KBRD(0)
	ENDREP UNTIL STRLOWCASE(quit) EQ 'q' 
;//	endfor
ABORT_RT:
	if (0 NE result) then printerrormessage, result
	;//	通信を終える際の処理
	;//	サーバとの接続クローズ
	result = call_external( object, symbol_Close, hnd)

	;//	DLL 内の終了処理を指示
	result = call_external( object, symbol_End)
END

;//	カメラ用プロシージャ
PRO	TVMonitor,diagName,channelNumber,udp,thinning=thinnings,mode=imageformat,host=dashost
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		RTCameraRetrieve
	endif
	if( n_params(0) eq 2) then begin
		udp = 0
	endif
	;//	間引き率の設定
	if (KEYWORD_SET(thinnings)) then begin
		thin = long(thinnings)
	endif else begin
		thin = long(1)
	endelse
	RTCameraRetrieve,diagName,fix(channelNumber),long(udp),thinning=thin,mode=modename,host=dashost
END
PRO	RTCameraRetrieve,diagName,channelNumber,udp,thinning=thinnings,mode=imageformat,host=dashost
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		print, 'Usage:'

		print, '  TVMonitor,diagName,channelNumber[,UDPportNumber][,thinning=N],[mode=ModeName]'

		print, ' '
		print, 'Input Parameters:'
		print, '  < diagName      - Diagnostics name'
		print, '  < channelNumber - Channel number'
		print, '  < UDPportNumber - UDP port number'
		print, '  < thinning=N    - set transfer thinning rate to 1/N'
		print, '  < mode=ModeName - camera image format (''GRAYn''(default:GRAY8), ''RGB'', ''UYVY'', ''YUY2'')'
		print, '  < host=HostName - Host name (''DAS15'',.., etc.)'
		retall
	endif
	
	;//	DLLのある場所を指定
	if( !version.memory_bits eq 64 ) then object = !Retrieve + '/bin64/RTTransClientDLL.dll' $
	else object = !Retrieve + '/bin/RTTransClientDLL.dll'

	;//	それぞれのDLL関数名を指定
	symbol_Start	= 'IdlLRTCameraStart'
	symbol_End	= 'IdlLRTCameraEnd'
	symbol_Open	= 'IdlLRTCameraOpen'
	symbol_Close	= 'IdlLRTCameraClose'
	symbol_SetInf	= 'IdlLRTCameraSetInf'
	symbol_GetParam = 'IdlLRTCameraGetChannelParam'
	symbol_GetData	= 'IdlLRTCameraGetChannelData'
	symbol_GetDataFromYUVCamera	= 'IdlLRTYUVCameraGetChannelData'
	symbol_GetChParam = 'IdlLRTGetChParam'


	;//	通信のために使用するハンドル用配列を作成
	;//	充分なサイズがあれば、どのような配列でも可
	;//	この配列の中身についてはDLL内で使用するが、PV-Wave側からでは
	;//	意味の無い値になります
	hnd = intarr(64)

	;//	DLL関数にアクセスし、値を取得したい変数の領域確保
	status = long(0)
	pixelDipth = long(0)
	frameRate = long(0)
	frameWidth = long(0)
	frameHeight = long(0)
	valueLen = 0
	recLen = long(0)
	packetSize = long(0)

	;//	サーバへの接続開始要求
	result = call_external( object, symbol_Start)
	if (result ne 0) then begin
		printerrormessage, result
		retall
	endif

	;//	計測名、チャネル番号などを指定し、データ受信用ハンドルを取得
	if (KEYWORD_SET(dashost)) then begin
		result = call_external( object, symbol_Open,$
			diagName, channelNumber, thinnings, hnd, udp, packetSize, dashost, VALUE=[1,0,0,0,0,0,1])
	endif else begin
		result = call_external( object, symbol_Open,$
			diagName, channelNumber, thinnings, hnd, udp, packetSize,VALUE=[1,0,0,0,0,0])
	endelse
	if (result ne 0) then begin
		printerrormessage, result
		retall
	endif

	if (NOT KEYWORD_SET(imageformat)) then begin
		imageType = bytarr(256)
		result = call_external( object, symbol_GetChParam,$
							hnd, 'ImageType', imageType,VALUE=[0,1,0])
		if (result ne 0) then GOTO, ABORT_PROC
		imageformat = string(imageType)
	endif
	
	cameramode = 1	;//	default:GRAY8
	arraybits=8
	if(STRUPCASE(imageformat) EQ 'GRAY8') then begin
		print, 'Image Type [GRAY8]'
		arraybits=8
	endif else if(STRUPCASE(imageformat) EQ 'GRAY9') then begin
		print, 'Image Type [GRAY9]'
		arraybits=9
	endif else if(STRUPCASE(imageformat) EQ 'GRAY10') then begin
		print, 'Image Type [GRAY10]'
		arraybits=10
	endif else if(STRUPCASE(imageformat) EQ 'GRAY11') then begin
		print, 'Image Type [GRAY11]'
		arraybits=11
	endif else if(STRUPCASE(imageformat) EQ 'GRAY12') then begin
		print, 'Image Type [GRAY12]'
		arraybits=12
	endif else if(STRUPCASE(imageformat) EQ 'GRAY13') then begin
		print, 'Image Type [GRAY13]'
		arraybits=13
	endif else if(STRUPCASE(imageformat) EQ 'GRAY14') then begin
		print, 'Image Type [GRAY14]'
		arraybits=14
	endif else if(STRUPCASE(imageformat) EQ 'GRAY15') then begin
		print, 'Image Type [GRAY15]'
		arraybits=15
	endif else if(STRUPCASE(imageformat) EQ 'GRAY16') then begin
		print, 'Image Type [GRAY16]'
		arraybits=16
	endif else if(STRUPCASE(imageformat) EQ 'RGB') then begin
		print, 'Image Type [RGB]'
		cameramode = 2
		Rseq = 0
		Gseq = 1
		Bseq = 2
	endif else if(STRUPCASE(imageformat) EQ 'RBG') then begin
		print, 'Image Type [RBG]'
		cameramode = 2
		Rseq = 0
		Gseq = 2
		Bseq = 1
	endif else if(STRUPCASE(imageformat) EQ 'GRB') then begin
		print, 'Image Type [GRB]'
		cameramode = 2
		Rseq = 1
		Gseq = 0
		Bseq = 2
	endif else if(STRUPCASE(imageformat) EQ 'GBR') then begin
		print, 'Image Type [GBR]'
		cameramode = 2
		Rseq = 2
		Gseq = 0
		Bseq = 1
	endif else if(STRUPCASE(imageformat) EQ 'BRG') then begin
		print, 'Image Type [BRG]'
		cameramode = 2
		Rseq = 1
		Gseq = 2
		Bseq = 0
	endif else if(STRUPCASE(imageformat) EQ 'BGR') then begin
		print, 'Image Type [BGR]'
		cameramode = 2
		Rseq = 2
		Gseq = 1
		Bseq = 0
	endif else if(STRUPCASE(imageformat) EQ 'UYVY') then begin
		print, 'Image Type [YUV422:UYVY]'
		cameramode = 3
		yuvfmt=0
	endif else if(STRUPCASE(imageformat) EQ 'YUV422') then begin
		print, 'Image Type [YUV422:UYVY]'
		cameramode = 3
		yuvfmt=0
	endif else if(STRUPCASE(imageformat) EQ 'YUY2') then begin
		print, 'Image Type [YUV422:YUY2]'
		cameramode = 3
		yuvfmt=1
	endif else begin
		print, 'Unknown format [',imageformat,'], ignored. Considering as [GRAY8]'
		GOTO, ABORT_PROC
	endelse

	;//	通信パラメータを取得
	result = call_external( object, symbol_GetParam,$
		hnd, status, pixelDipth, frameRate, frameWidth, frameHeight, recLen, packetSize)
	if (result ne 0) then GOTO, ABORT_PROC
	
	prePixelDipth = pixelDipth
	preFrameWidth = frameWidth
	preFrameHeight = frameHeight

	;//	間引き率を指定
	;//	IdlLRTOpen を呼び出すときに指定した間引き率に変更がなければ
	;//	この処理は省くことができます
	result = call_external( object, symbol_SetInf,$
						hnd, thinnings)
	if (result ne 0) then GOTO, ABORT_PROC
	
	;//	データ受信用バッファ作成
	if(cameramode EQ 1) then begin
		if (arraybits LE 8) then begin
			buf = bytarr(frameWidth, frameHeight)
		endif else begin
			buf = intarr(frameWidth, frameHeight)
		endelse
	endif else if(cameramode EQ 2) then begin
		buf = bytarr(4, frameWidth, frameHeight)
		dsp = bytarr(3, frameWidth, frameHeight)
	endif else if(cameramode EQ 3) then begin
		buf = bytarr(3, frameWidth, frameHeight)
	endif ;//	現状、YUV422からRGBへの変換のみ対応

	window, 1, XSize=frameWidth, YSize=frameHeight
	wshow, 1, 1
	quit='p'
	is_gdl=1
	if( -1 EQ strpos(strupcase(!DIR),'GDL') ) then is_gdl=0
	print,'Terminate when "q" or "Q" is entered.'

	;//	データ受信のためのループ
;//	for loopn=1, 10000 do begin
	repeat begin
		;//	データ受信する際に、ショット番号などを受け取るための領域確保
		shot = long(0);
		subshot = long(0);

		;//	ブロック番号は1から始まり、サーバから次のブロックが
		;//	送られてくるごとにシーケンシャルに増えていきます
		blk = long(0);

		;//	受信したブロック中の先頭と最終サンプリングデータが
		;//	収集データ中で何番目にあたるかを示します
		head = long64(0);
		tail = long64(0);

		;//	送られてきたブロックのサイズ
		blen = long(0);

		;//	データ受信関数を呼び出す
		if((cameramode EQ 1) OR (cameramode EQ 2)) then begin
			result = call_external( object, symbol_GetData, hnd, status, shot, subshot, blk, head, tail, buf, blen)
		endif else begin
			result = call_external( object, symbol_GetDataFromYUVCamera, hnd, status, shot, subshot, blk, head, tail, buf, blen, yuvfmt)
		endelse

		;//	status は -1, 3, 5, 8 が返ってくる可能性があります
		;//	-1 は意味のあるデータ無しで、他の変数にも無意味な値が入っていますので
		;//	処理なく破棄します
		;//	プラズマデータ収集開始前はほぼすべて -1 になり、
		;//	またデータ収集中でもデータ生成待ちのときには -1 が返ってきます

		;//	3, 5 はサーバがそれぞれモジュールセットアップと初期化を行ったときに返ってきます
		;//	ショット番号、サブショット番号には有効な値が入っていますので
		;//	必要な処理があれば利用できます
		;//	このサンプルでは何も処理していません

		;//	8 はプラズマ計測中にデータが送られてきたときに返ってきます
		;//	他の変数にもそれぞれ有効な値が入り、
		;// 指定したバッファには受信したデータが入ります


		;//	データを受信した際の処理
		;//	このサンプルでは、エラー処理を考えず、受け取ったバッファを
		;//	次々にプロット用の配列に入れていき、スクロールさせながら
		;//	表示するようになっています
		;//	実際にはパケット取りこぼした際などのため、ブロック番号、head,tail など
		;//	を用いて取りこぼしたデータは飛ばして表示するほうが正しいものとなります
		if ( -1 EQ status ) then GOTO,NEXT_LOOP
		if ( blen GT 0 )then begin
			print,'frame num = ',blk
			if(cameramode EQ 2) then begin
				dsp(0, *, *) = buf(rseq,*,*)
				dsp(1, *, *) = buf(gseq,*,*)
				dsp(2, *, *) = buf(bseq,*,*)
			endif
			erase,1
			if(cameramode EQ 1) then begin
				tvscl, buf, /order
			endif else if(cameramode EQ 2) then begin
				tvscl, dsp, true=1, /order
			endif else begin
				tvscl, buf, true=1, /order
			endelse
			wshow,1,1

			wait, 0.01
		endif else if( (status EQ 3) OR (status EQ 5) ) then begin	;//	画素数などを取得しなおして処理
			result = call_external( object, symbol_GetParam,$
						hnd, status, pixelDipth, frameRate, frameWidth, frameHeight, recLen, packetSize)
			if (result ne 0) then GOTO,ABORT_PROC
			if ( (prePixelDipth NE pixelDipth) OR (preFrameWidth NE frameWidth) OR (preFrameHeight NE frameHeight) ) then begin
				;//	データ受信用バッファ作成
				if(cameramode EQ 1) then begin
					if (arraybits LE 8) then begin
						buf = bytarr(frameWidth, frameHeight)
					endif else begin
						buf = intarr(frameWidth, frameHeight)
					endelse
				endif
	
				if(cameramode EQ 2) then begin
					buf = bytarr(4, frameWidth, frameHeight)
					dsp = bytarr(3, frameWidth, frameHeight)
				endif
				
				if(cameramode EQ 3) then begin
					buf = bytarr(3, frameWidth, frameHeight)
				endif ;//	現状、YUV422からRGBへの変換のみ対応
	
				if ( (preFrameWidth NE frameWidth) OR (preFrameHeight NE frameHeight) ) then begin
					window, 1, XSize=frameWidth, YSize=frameHeight
					wshow, 1, 1
				endif

				prePixelDipth = pixelDipth
				preFrameWidth = frameWidth
				preFrameHeight = frameHeight
			endif
		endif
NEXT_LOOP:
		if( 0 EQ is_gdl ) then quit = GET_KBRD(0)
	ENDREP UNTIL STRLOWCASE(quit) EQ 'q' 
;//	endfor
ABORT_PROC:
	if (result ne 0) then printerrormessage, result

	;//	通信を終える際の処理
	;//	サーバとの接続クローズ
	result = call_external( object, symbol_Close, hnd)

	;//	DLL 内の終了処理を指示
	result = call_external( object, symbol_End)
END
