;// RETRIEVE procedure for PV-WAVE ( with retrieve.dll )
;//	Copyright 1998-2008,  NIFS LABCOM
;//	Original Auther: Kojima Mamoru
;//
;//	Add "TotalSize": @20021216
;//
;// Modification Histories
;//	1998/11/4(Kojima M.)		If error, it returns with dataArray=long(0) and prints error code.
;//	1998/11/13			"object" pathname is made from O2HOME env. var.
;//	1998/11/14			change caluclation of re-allocated dataArray size
;//	1998/12/24			複数チャネル指定ができるように改造
;// 	1999/01/14(Y.Oguri)		サプショット番号を指定するように変更
;// 	1999/01/18(Y.Oguri)		サーバ名を Indexd から取得するように変更
;// 	1999/01/28(H.Sugisaki)	データ転送をデータ転送サーバのみからの取得に変更
;// 	1999/11/18(H.Sugisaki)	プロシージャにリターンコードを追加
;// 	2000/09/14(Kojima M.)	キーワードパラメータを付加してパラメータを取得できるように拡張
;//					取得したパラメータの変換ファンクションを追加
;//					DLL参照PathをLinux版と合わせてフルパス指定に変更
;//					Getinfo関数のパラメータ変更（number＋version→manageVersion）
;//	2001/04/11(Nonomura M.)	SX対応 DataSizeが 0 の場合でもパラメータを取得できるように変更
;//	2002/02/04(Komada S.)	Ver.5.0.0　ANA/RAW情報の間違い等の各種バグを修正．
;//	2002/07/22(Kojima M.)	取得したパラメータの文字列変換ファンクションを追加
;//	2002/11/19(Ohsuna M.)	Long,Float,Double型データ配列の取得に対応
;//	2002/12/24(Kojima M.)	共有メモリデータの高速読出しプロシージャ"retrieveFast*"を追加
;//	2003/01/09(Yoshida M.)	共有メモリデータの高速読出しプロシージャの呼び出しをkeyWord(host)で分岐に変更
;//	2003/09/19(Nakanishi)	getParam*()関数群でチャネル数指定の第3引数を正しく処理できないバグを修正
;//	2004/09/27(Ohsuna M.)	明示的にtransdとの接続をクローズするように変更
;//	2005/12/13(Ohsuna M.)	64bit Integerのパラメータの型名を表示するように修正
;//							配列の型を Resolution(bit) パラメータから BYTE,INT,LONG に判別
;//	2007/07/31(Imazu S.)	LABCOM-X Frame対応　および　プロトコル更新, /Silent
;//	2007/10/03(Imazu S.)	retrieveFLT,retrieveDBLの引数
;//	2008/03/28(Imazu S.)	マルチサイト　データ移送対応
;//	2008/08/03(Imazu S.)	DLL更新、セキュリティ対策
;//	2008/10/28(Imazu S.)	DLL更新(retrieve_t)
;//	2008/11/25(Imazu S.)	DLL更新(retrieve),CurrentSite,ChangeSite追加,dll version
;//	2008/12/16(Imazu S.)	DLL更新(retrieve 12.2.0) media別受信タイムアウト
;//	2009/02/25(Imazu S.)	DLL更新 add setenv,'INDEXSERVERNAME=DASINDEX'
;//	2009/07/13(Imazu S.)	DLL更新 13.0.0 wait(timeout)機能追加
;//	2009/07/29(Imazu S.)	13.1.0 waitオプション追加　時間設定はtimeoutオプション　デフォルト180
;//	2010/03/12(Imazu S.)	vflt(v4),vdbl(v8)オプション追加(電圧値変換)
;// 2010/08/30(Imazu S.)	 DLL compile only.
;// 2010/09/28(Imazu S.)	ChangeSite for pv-wave 9.5
;// 2011/06/13(Ohsuna M.)	Ver.15.0.0 x86 x86_64 インストーラ統合
;// 2011/08/04(Ohsuna M.)	retrieve_t修正(コマンドライン版及びWE7562の取扱いについて,PXI6255対応)
;// 2011/08/25(Imazu S.)	retrieve修正(WAITモードでの待ち時間に関する不具合修正)
;// 2012/07/31(Imazu S.)	ver.16.0.0
;// 						retrieve修正(FRAME SIZE != XY SIZE対応),Channel指定方法の拡大
;// 						retrieve_tへの手続き変更
;// 2013/10/01(Imazu S.)	ver.17.0.0 PXIe5185電圧値変換
;// 2015/11/01(Imazu S.)	ver.19.0.0 et,tt,ssオプション追加(部分取り出し)
;// 2016/10/19(Imazu S.)	ver.19.1.0 内部処理 LON64対応,/shottime, signed8ToInt()
;// 2017/07/28(Imazu S.)	ver.19.2.0 DLL更新(PXIe-6368対応)
;// 2018/05/25(Imazu S.)	ver.20.0.0 64ビット判定を!version.archから!version.memory_bitsに変更(GDL共通化のため)
;// 2020/06/01(Imazu S.)	ver.22.0.0 cnvUYVYtoRGB, cnvYUY2toRGB追加
;//
;// IDL/GDLは32/64ともに同じ型Depth, fix,long,long64, 16/32/64

;defsysv,'!Retrieve',getenv('Retrieve'),1
PRO ver
	print, 'LABCOM Retrieve ver. 22.0.0'
END
PRO version,dll=dll
	ver
	if (KEYWORD_SET(dll)) then begin
		if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
		else object = !Retrieve + '/bin/retrieve.dll'
		dll_ver = CALL_EXTERNAL( object, 'IdlRetrieveVersion', /S_Value)
		print, 'retrieve.dll ver. ',dll_ver
	endif
END

PRO retrieve,diagName,shotNumber,subShotNumber,channelNumber,dataArray,code,param=params,tarray=ta,tparam=tp,double=double,host=dashost,path=basepath,frame=frameno,$
silent=silent,wait=wait_sw,timeout=wait_sec,vflt=vflt,vdbl=vdbl,v4=v4,v8=v8,et=etrange,tt=ttrange,ss=ssrange,shottime=shot_t
	ArrayType = -1		;	Array指定なし

	;// add 2003/1/9
	if (KEYWORD_SET(dashost)) then begin	;// HOST指定あり(高速読出し)
		hostName = dashost
	endif else begin						;// HOST指定なし（通常読み出し）
		hostName = 'NONE'
	endelse

	if (KEYWORD_SET(basepath)) then begin
		baseName = basepath
	endif else begin
		if (KEYWORD_SET(dashost)) then begin
			baseName = 'ShotDataFS'
		endif else begin
			baseName = ''
		endelse
	endelse

	if (KEYWORD_SET(v4)) then 	vflt = v4
	if (KEYWORD_SET(v8)) then 	vdbl = v8
	checkParams, n_params(0), ArrayType, code,wait=wait_sw,timeout=wait_sec,vflt=vflt,vdbl=vdbl,et=etrange,tt=ttrange,ss=ssrange,frame=frameno
	if(code EQ 0) then begin
		volts = 0
		if (KEYWORD_SET(vflt)) then 	volts = 1
		if (KEYWORD_SET(vdbl)) then 	volts = 2
		retrieve_ex,hostName,baseName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
			tarray=ta,tparam=tp,double=double,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec,volts=volts,$
			et=etrange,tt=ttrange,ss=ssrange,shottime=shot_t
	endif
END
;// et,tt,ss cannot support
PRO retrieve8,diagName,shotNumber,subShotNumber,channelNumber,dataArray,code,param=params,$
			tarray=ta,tparam=tp,double=double,host=dashost,path=basepath,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	ArrayType = 0		;//	8bit (byte)

	;// add 2003/1/9
	if (KEYWORD_SET(dashost)) then begin	;// HOST指定あり(高速読出し)
		hostName = dashost
	endif else begin						;// HOST指定なし（通常読み出し）
		hostName = 'NONE'
	endelse

	if (KEYWORD_SET(basepath)) then begin
		baseName = basepath
	endif else begin
		if (KEYWORD_SET(dashost)) then begin
			baseName = 'ShotDataFS'
		endif else begin
			baseName = ''
		endelse
	endelse

	checkParams, n_params(0), ArrayType, code,wait=wait_sw,timeout=wait_sec
	if(code EQ 0) then begin
		retrieve_ex,hostName,baseName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
					tarray=ta,tparam=tp,double=double,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	endif
END

PRO retrieve16,diagName,shotNumber,subShotNumber,channelNumber,dataArray,code,param=params,$
			tarray=ta,tparam=tp,double=double,host=dashost,path=basepath,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	ArrayType = 1		;//	16bit (short int)

	;// add 2003/1/9
	if (KEYWORD_SET(dashost)) then begin	;// HOST指定あり(高速読出し)
		hostName = dashost
	endif else begin						;// HOST指定なし（通常読み出し）
		hostName = 'NONE'
	endelse

	if (KEYWORD_SET(basepath)) then begin
		baseName = basepath
	endif else begin
		if (KEYWORD_SET(dashost)) then begin
			baseName = 'ShotDataFS'
		endif else begin
			baseName = ''
		endelse
	endelse

	checkParams, n_params(0), ArrayType, code,wait=wait_sw,timeout=wait_sec
	if(code EQ 0) then begin
		retrieve_ex,hostName,baseName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
				tarray=ta,tparam=tp,double=double,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	endif
END

PRO retrieve32,diagName,shotNumber,subShotNumber,channelNumber,dataArray,code,param=params,$
			tarray=ta,tparam=tp,double=double,host=dashost,path=basepath,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	ArrayType = 2		;//	32bit (long int)

	;// add 2003/1/9
	if (KEYWORD_SET(dashost)) then begin	;// HOST指定あり(高速読出し)
		hostName = dashost
	endif else begin						;// HOST指定なし（通常読み出し）
		hostName = 'NONE'
	endelse

	if (KEYWORD_SET(basepath)) then begin
		baseName = basepath
	endif else begin
		if (KEYWORD_SET(dashost)) then begin
			baseName = 'ShotDataFS'
		endif else begin
			baseName = ''
		endelse
	endelse

	checkParams, n_params(0), ArrayType, code,wait=wait_sw,timeout=wait_sec
	if(code EQ 0) then begin
		retrieve_ex,hostName,baseName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
				tarray=ta,tparam=tp,double=double,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	endif
END

PRO retrieveFLT,diagName,shotNumber,subShotNumber,channelNumber,dataArray,code,param=params,$
			tarray=ta,tparam=tp,double=double,host=dashost,path=basepath,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	ArrayType = 3		;//	32bit (float)

	;// add 2003/1/9
	if (KEYWORD_SET(dashost)) then begin	;// HOST指定あり(高速読出し)
		hostName = dashost
	endif else begin						;// HOST指定なし（通常読み出し）
		hostName = 'NONE'
	endelse

	if (KEYWORD_SET(basepath)) then begin
		baseName = basepath
	endif else begin
		if (KEYWORD_SET(dashost)) then begin
			baseName = 'ShotDataFS'
		endif else begin
			baseName = ''
		endelse
	endelse

	checkParams, n_params(0), ArrayType, code,wait=wait_sw,timeout=wait_sec
	if(code EQ 0) then begin
		retrieve_ex,hostName,baseName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
				tarray=ta,tparam=tp,double=double,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	endif
END

PRO retrieveDBL,diagName,shotNumber,subShotNumber,channelNumber,dataArray,code,param=params,$
			tarray=ta,tparam=tp,double=double,host=dashost,path=basepath,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	ArrayType = 4		;//	64bit (double float)

	;// add 2003/1/9
	if (KEYWORD_SET(dashost)) then begin	;// HOST指定あり(高速読出し)
		hostName = dashost
	endif else begin						;// HOST指定なし（通常読み出し）
		hostName = 'NONE'
	endelse

	if (KEYWORD_SET(basepath)) then begin
		baseName = basepath
	endif else begin
		if (KEYWORD_SET(dashost)) then begin
			baseName = 'ShotDataFS'
		endif else begin
			baseName = ''
		endelse
	endelse

	checkParams, n_params(0), ArrayType, code,wait=wait_sw,timeout=wait_sec
	if(code EQ 0) then begin
		retrieve_ex,hostName,baseName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
				tarray=ta,tparam=tp,double=double,frame=frameno,silent=silent,wait=wait_sw,timeout=wait_sec
	endif
END

PRO checkParams, num_params, ArrayType, err,wait=wait_sw,timeout=wait_sec,vflt=vflt,vdbl=vdbl,et=etrange,tt=ttrange,ss=ssrange,frame=frameno
	err = 0
	range_option = 0;
	if ( KEYWORD_SET(etrange) ) then range_option = range_option + 1
	if ( KEYWORD_SET(ttrange) ) then range_option = range_option + 1
	if ( KEYWORD_SET(ssrange) ) then range_option = range_option + 1
	if ( KEYWORD_SET(frameno) ) then range_option = range_option + 1
	if( range_option GE 2 ) then err = -2
    if ( KEYWORD_SET(wait_sw) ) then begin
    	if ( KEYWORD_SET(wait_sec)) then begin
			tm_info = size(wait_sec,/type)
			if( tm_info NE 2 ) AND ( tm_info NE 3 ) then err = -2
		endif
		if( range_option NE 0 ) then err = -2
    endif
    if ( KEYWORD_SET(vflt) AND KEYWORD_SET(vdbl)) then err = -2

	if( num_params NE 5 ) AND ( num_params NE 6 ) OR ( err NE 0 ) then begin

		if( ArrayType EQ 0) then begin
			exec_name =  '  retrieve8'
		endif else if( ArrayType EQ 1) then begin
			exec_name =  '  retrieve16'
		endif else if(ArrayType EQ 2) then begin
			exec_name =  '  retrieve32'
		endif else if(ArrayType EQ 3) then begin
			exec_name =  '  retrieveFLT'
		endif else if(ArrayType EQ 4) then begin
			exec_name =  '  retrieveDBL'
		endif else begin
			exec_name =  '  retrieve'
		endelse

		print, 'Usage:'
		print, exec_name+',diagName,shot#,subShot#,ch#,dataArray[,returnCode][,param=keyParams]'
		if( ArrayType EQ -1 ) then begin
			print,'          [,tarray=timeArray][,tparam=timeParams][,/double]'
			print,'          [,et=range_value | tt=range_value | ss=range_value | frame=Frame#]'
		endif else begin
			print,'          [,tarray=timeArray][,tparam=timeParams][,/double][,frame=Frame#]'
		endelse
		print,'          [,host=HostName[,path=SharedPath]][,/wait[,timeout=WaitSec]]'
		if( ArrayType EQ -1) then begin
			print,'          [,/vflt | /vdbl | /v4 | /v8][,/silent][,shottime=shot_t]'
		endif else begin
			print,'          [,/silent]'
		endelse
		print, ' '
		print, 'Input Parameters:'
		print, '  < diagName - Diagnostics name (''Magnetics'',.., etc.)'
		print, '  < shot#    - Shot number'
		print, '  < subShot# - Sub shot number'
		print, '  < ch#      - Channel number(s) (e.g. ''1,5,7-11'',''1,5,7:11'',''0''=all)'
		print, '                or a signal tag name (e.g. ''sig-tag1'') '
		if( ArrayType EQ -1 ) then begin
			print, '  < et=range_value  - retrieve range by time of an experiment'
			print, '         range_value : ''Begin:EndUnit'' e.g. ''1.0:2.0s''(s,ms,us) '
			print, '  < tt=range_value  - retrieve range by relative time from trigger'
			print, '         range_value : same as ''et'' parameter
			print, '  < ss=range_value  - retrieve range by sample number'
			print, '         range_value : ''Begin#:End#'' e.g. ''2000:3000'' '
		endif
		print, '  < frame=Frame#    - Frame number (multiple frames->''start#:end#'')'
		print, '  < host=HostName   - Host name (''DAS15'',.., etc.)'
		print, '  < path=SharedPath - Shared path name (''ShotData11'',.., etc.), with ''host'' parameter'
		print, '  < /wait           - waiting data mode. It can''t be used with ''et'',''tt''.''ss''.'
		print, '  < timeout=WaitSec - time for waiting data. second unit. default 180'
		if( ArrayType EQ -1) then begin
		print, '  < /vflt, /v4      - convert to voltage or real number (in float type range)'
		print, '  < /vdbl, /v8      - convert to voltage or real number (in double type range)'
		endif
		print, '  < /silent         - no display without error message'
		print, '  < /double         - return time array in double type (ignored if tarray option does not exist)'
		print, ' '
		print, 'Output Parameters:'
		print, '  > dataArray       - Data array'
		print, '  > returnCode      - Returned error code (option)'
		print, '  > param=keyParams - Returned parameter (option)'
		print, '  > tarray=timeArray  - Time Array(option)'
		print, '  > tparam=timeParams - Returned parameter for time information (option)'
		print, '                      (keyParams or timeArray,timeParams must be pre-defined, i.e. keyParams=1)'
		if( ArrayType EQ -1 ) then begin
		print, '  > shottime=shot_t - Returned the time when stored to files. (option, string)'
		endif
		print, ' '
		print, 'Utility for retrieved parameters:'
		print, '  * strValue = getParamString( paramName, keyParams, (chanNumber))'
		print, '  * integerValue = getParamInt( paramName, keyParams, (chanNumber))'
		print, '  * longValue = getParamLong( paramName, keyParams, (chanNumber))'
		print, '  * long64Value = getParamLong64( paramName, keyParams, (chanNumber))'
		print, '  * floatValue = getParamFloat( paramName, keyParams, (chanNumber))'
		print, '  * doubleValue = getParamDouble( paramName, keyParams, (chanNumber))'
		print, '  * printParam, keyParams'
		print, 'Utility for retrieved array:'
		print, '  * intArray = signed8toInt( byteArray)'
		print, '  * rgb_array = cnvUYVYtoRGB( yuv_array [,/scA64070gc])'
		print, '  * rgb_array = cnvYUY2toRGB( yuv_array)'
		err=-1
		retall
	endif
END

;//
;// print message or convert to message from error code for retrieve.dll
;//
;//		Parameter(in) : errorCode   -> error code
;//
;//				(out) :	error_mes   ->return message
;//
FUNCTION retrieve_message, errorCode
    if( 0  NE N_elements(errorCode) ) then begin
		if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
		else object = !Retrieve + '/bin/retrieve.dll'
		return,CALL_EXTERNAL( object, 'IdlRetrieveErrorMessage', long(errorCode), /S_Value)
	endif
	return,''
END
PRO retrieve_message, errorCode, error_mes

	if ( n_params(0) NE 1 AND n_params(0) NE 2) then begin
		print, 'Usage:'
		print, ' retrieve_message, errorCode [, error_mes]'
		print, ' '
		print, ' Input Arguements:'
		print, '   > errorCode   -- error code (e.g. -10)'
		print, ' Output Arguements:'
		print, '   > error_mes   -- (optinal) error message'
		print, ' '
		return
	endif

	if( n_params(0) EQ 1 ) then begin
		print,retrieve_message(errorCode)
	endif else begin
		error_mes = retrieve_message(errorCode)
	endelse

END


FUNCTION retrieve_close, rtrDes
    if( 0  NE N_elements(rtrDes) ) then begin
		if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
		else object = !Retrieve + '/bin/retrieve.dll'
		return,CALL_EXTERNAL( object, 'IdlRetrieveClose', rtrDes )
	endif
	return,-1
END
FUNCTION channel_decode,channelNumber,st_recs,en_recs
	chs_cnt = 0
	ctype = size(channelNumber)
	if ( ctype(0) EQ 0 ) then begin
		if( ctype(1) le 3 ) then begin
			chs_cnt =1
			st_recs = intarr(1)
			en_recs = intarr(1)
			st_recs(0) = fix( channelNumber )
			en_recs(0) = fix( channelNumber )
		endif else if( ctype(1) EQ 7 ) then begin
			if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
			else object = !Retrieve + '/bin/retrieve.dll'
			code = CALL_EXTERNAL( object, 'IdlChannelDecode', channelNumber, chs_cnt, VALUE=[1,0] )
			if( 0 NE code ) then begin
				return,-1
			endif
			if( 0 EQ chs_cnt ) then return,0
			st_recs = intarr(chs_cnt)
			en_recs = intarr(chs_cnt)
			code = CALL_EXTERNAL( object, 'IdlChannelDecode', channelNumber, st_recs, en_recs, VALUE=[1,0,0] )
			if( 0 NE code ) then begin
				return,-1
			endif
		endif else begin
			return,-1
		endelse
	endif else if ( ctype(0) EQ 1 ) then begin
		if( ctype(2) ge 4 ) then begin
			return,-1
		endif
		chs_cnt =  ctype(1)
		st_recs = intarr(chs_cnt)
		en_recs = intarr(chs_cnt)
		st_recs = channelNumber;
		en_recs = channelNumber;
	endif else begin
		return,-1
	endelse
	return,chs_cnt
END
PRO retrieve_ex,hostName,pathName,diagName,shotNumber,subShotNumber,channelNumber,dataArray,ArrayType,code,param=params,$
				tarray=ta,tparam=tp,double=double,frame=frameno,$
				silent=silent,wait=wait_sw,timeout=wait_sec,volts=volts,noarray=noarray,$
				et=etrange,tt=ttrange,ss=ssrange,shottime=shot_t
	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'

	if (KEYWORD_SET(silent)) then begin
		isSilent = 1
		isnotSilent = 0
	endif else begin
		isSilent = 0
		isnotSilent = 1
	endelse

	range_type = 0L;
	range_str = "";
	if (KEYWORD_SET(etrange)) then begin
		range_type = 1L;
		range_str = etrange;
	endif
	if (KEYWORD_SET(ttrange)) then begin
		range_type = 2L;
		range_str = ttrange;
	endif
	if (KEYWORD_SET(ssrange)) then begin
		range_type = 3L;
		range_str = ssrange;
	endif
	if (KEYWORD_SET(frameno)) then begin
		range_type = 4L;
		range_str = string(frameno);
	endif

	sym_Open		= 'IdlRetrieveOpen'
	sym_OPenDirect	= 'IdlRetrieveOpenDirect'
	sym_ShotInfo	= 'IdlRetrieveShotInfo'
	sym_ChInfo		= 'IdlRetrieveChInfoEx'
	sym_ChData		= 'IdlRetrieveChDataEx'
	sym_ChParam		= 'IdlRetrieveChParam'
	sym_FrameInfo	= 'IdlRetrieveFrameInfoEx'
	sym_FrameData	= 'IdlRetrieveFrameDataEx'
	sym_GetDTSinfo  = 'IdlRetrieveTimeInfoEx'
	sym_GetDTSdata  = 'IdlRetrieveTimeDataEx'
	sym_IndexCntl	= 'IdlIndexNoClosing'
	sym_RetrieveNo	= 'IdlRetrieveRetrieveNoEx'

	code = long(-1)
	rtd = long(0)
	Host_Name = hostName
	Diag_Name = diagName
	Server = bytarr(32)
	IndexServer = getenv('INDEXSERVERNAME')
	AShot_Number = long( shotNumber )
	ASub_Shot_Number= fix ( subShotNumber )
	LastCh = fix(0)
	YY = fix(0)
	MM = fix(0)
	DD = fix(0)
	hh = fix(0)
	m  = fix(0)
	ss = fix(0)
    wait_time_sec = long(0);
	if (KEYWORD_SET(wait_sw)) then begin
		if (KEYWORD_SET(wait_sec)) then begin
			wait_time_sec = long(wait_sec)
		endif else begin
			wait_time_sec = long(180);
		endelse
	endif

	manageVersion = bytarr(256)
	comment = bytarr(256)
	commentsize = long(256)

	if( IndexServer EQ '' ) then begin
		setenv,'INDEXSERVERNAME=DASINDEX'
		IndexServer = getenv('INDEXSERVERNAME')
	endif

	;//	channel decode
	signal_name = 0
	chs_cnt = channel_decode( channelNumber, st_recs, en_recs)
	if( chs_cnt le 0 ) then begin
		ctype = size(channelNumber)
		if( chs_cnt EQ 0 AND ctype(0) EQ 0 AND ctype(1) EQ 7 ) then begin
			chs_cnt = 1
			st_recs = 1
			en_recs = 1
			signal_name = 1
		endif else begin
			if(isnotSilent) then $
				print,'<Error: Illegal channel number!>'
			return
		endelse
	endif

	if( KEYWORD_SET(frameno) ) then begin
		if( KEYWORD_SET(volts) ) then begin
			if(isnotSilent) then $
				print,'<Error: converting to voltage or real number from frame data is not supported.>'
			return
		endif
	endif

	if  N_elements(ta) NE 0 or N_elements(tp) NE 0 then begin
		sw_time = 1
		if (KEYWORD_SET(double)) then begin
			isDouble = 1L
		endif else begin
			isDouble = 0L
		endelse
	endif else begin
		sw_time = 0
	endelse

	rtd = CALL_EXTERNAL( object, sym_IndexCntl, 1,VALUE=[1])	;// Caution by Value
	if( Host_Name EQ 'NONE' ) then begin
		symbol = sym_Open;
		rtd = CALL_EXTERNAL( object, sym_Open, Diag_Name, IndexServer, AShot_Number, ASub_Shot_Number,wait_time_sec $
							,range_type,range_str,VALUE=[1,1,0,0,0,0,1] )
	endif else begin
		Server		= Host_Name
		Server_Path = pathName
		Server_Port = long(0)
		symbol = sym_OpenDirect;
		rtd = CALL_EXTERNAL( object, sym_OpenDirect, Diag_Name, Server, Server_Path,  AShot_Number, ASub_Shot_Number, Server_Port,wait_time_sec $
							,VALUE=[1,1,1,0,0,0,0] )
	endelse

	if( rtd lt 0 ) then begin
		if(isnotSilent) then $
			print,'Error from DLL( ',symbol,' )!',rtd,': ',retrieve_message(rtd)
		code=rtd
		rtd = CALL_EXTERNAL( object, sym_IndexCntl, 0,VALUE=[1])	;// Caution by value
		return
	endif

	rtn_server = bytarr(256)
	result = CALL_EXTERNAL( object, sym_ShotInfo ,rtd ,LastCh ,YY ,MM ,DD ,hh ,m ,ss ,manageVersion ,comment ,commentsize, rtn_server )
	if( result lt 0 ) then begin
		if(isnotSilent) then $
			print,'Error from DLL( ',sym_ShotInfo,' )!',result,': ',retrieve_message(result)
		goto, EXIT_PRO_1
	endif

	if(isnotSilent and NOT KEYWORD_SET(noarray) ) then begin
		print,'---Arc Shot Infomation---'
		print,'Index Server Name  = '  ,string(IndexServer)	,format='(A,A)'
		print,'Trans Server Name  = '  ,string(rtn_server)	,format='(A,A)'
		print,'Shot Number        = '  ,AShot_Number		,format='(A,I10)'
		print,'Sub Shot Number    = '  ,ASub_Shot_Number	,format='(A,I10)'
		print,'Channel            = '  ,LastCh        		,format='(A,I3)'
		print,'DATE               = '  ,YY,'-',MM,'-',DD	,format='(A,I4,A,I2,A,I2)'
		print,'TIME               = '  ,hh,':',m,':',ss		,format='(A,I2,A,I2,A,I2)'
		print,'Request Channel    = '  ,ChannelNumber
	endif
	if  N_elements(shot_t) NE 0  then begin
		shot_t = string(YY*10000L+MM*100L+DD,format='(I8.8)') +string(hh*10000L+m*100L+ss,format='(I6.6)')
	endif
	numOfCh = 0
	for i=0, chs_cnt-1 do begin
		if( st_recs(i) EQ 0 AND en_recs(i) EQ 0 ) then begin
			st_recs(i)=1
			en_recs(i)=LastCh
		endif
		if( en_recs(i) gt LastCh ) OR ( st_recs(i) gt LastCh ) OR $
		  ( en_recs(i) le 0 ) OR ( st_recs(i) le 0 ) then begin
		  	numOfCh = 0
		  	goto,BRK_FOR_1
		endif
		if( st_recs(i) le en_recs(i) ) then begin
		 	numOfCh = numOfCh + ( en_recs(i) - st_recs(i) + 1)
		endif else begin
			numOfCh = numOfCh + ( st_recs(i) - en_recs(i) + 1)
		endelse
	endfor
BRK_FOR_1:
	if(numOfCh le 0) then begin
		if(isnotSilent) then $
			print,'<Error: Illegal channel number!>'
		result = -1
		goto, EXIT_PRO_1
	endif

	dataSize = 0LL
	compSize = 0LL
	paramCount = fix(0)
	dataType = fix(0)
	imageType = bytarr(32)
	valueLen = fix(0)
	isnFrame =long(0)
	commentCh = bytarr(256)
	commentsizeCh = long(256)

	dataArray = intarr(1,1)
	PCount = fix(0)
	TotalSize = 0LL

	data_struct	= long(0)
	firstDataSize	= -1LL
	frameX			= long(0)
	frameY			= long(0)
	if( KEYWORD_SET(volts)) then begin
		sym_ChV	= 'IdlRetrieveChVEx'
		sym_ChVsynNum	= 'IdlRetrieveChVsynthesizedNumber'
		data_struct = long(3)
	endif

	loopCnt = 0
	FOR x=0,(chs_cnt-1) DO BEGIN
	step = 1
	if( st_recs(x) gt en_recs(x) ) then step = -1
	FOR tmp_chno=st_recs(x), en_recs(x), step DO BEGIN
		chno=long(tmp_chno)
		if( signal_name EQ 0 ) then begin
			result = CALL_EXTERNAL( object,sym_ChInfo ,rtd ,chno ,dataSize ,compSize ,paramCount ,$
				dataType ,imageType ,valueLen ,isnFrame ,manageVersion ,commentCh ,commentsizeCh )
		endif else begin
			real_chno = long(0)
			result = CALL_EXTERNAL( object,sym_ChInfo ,rtd ,channelNumber ,dataSize ,compSize, $
				paramCount, dataType, imageType, valueLen, isnFrame, manageVersion, commentCh, $
				commentsizeCh, real_chno, VALUE=[0,1,0,0,0,0,0,0,0,0,0,0,0])
			chno = real_chno
		endelse
		if( result lt 0 ) then begin
			if(isnotSilent) then $
				print,'Error from DLL( ',sym_ChInfo,' )!',result,': ',retrieve_message(result)
			goto, EXIT_PRO_1
		endif

		if( dataType EQ 0 ) then Type='RAW' else $		;// illegal
		if( dataType EQ 1 ) then Type='RAW' else $
		if( dataType EQ 2 ) then Type='ANA'

		if(isnotSilent and NOT KEYWORD_SET(noarray) ) then begin
			print,'---Channel Information---'
			print,'Channel Number     = '  ,chno				,format='(A,I4)'
			print,'Data Type          = '  ,Type				,format='(A,A)'
;;			print,'Image Type         = '  ,string(imageType)	,format='(A,A)'
			print,'Data Size          = '  ,dataSize			,format='(A,I12)'
			if( compSize NE 0 ) then $
			print,'Compressed Size    = '  ,compSize			,format='(A,I12)'
		endif

		if( 0 EQ data_struct ) then begin
			if ( 0 EQ isnFrame ) then begin
				data_struct = 1
			endif else begin
				data_struct = 2
			endelse
		endif

		if(KEYWORD_SET(noarray)) then dataSize = 0LL

		if( 1 EQ data_struct ) then begin

	 		if( dataSize EQ 0LL ) then begin	;//データサイズ0 回避 	パラメータのみ
				if(isnotSilent and NOT KEYWORD_SET(noarray) ) then $
					print,'Error! - Data Size is 0.'
				dataArray = 0L
			endif

			;//	データサイズが最初のチャネルのものより大きいとエラー
			if( -1LL EQ firstDataSize ) then begin
				firstDataSize = dataSize
			endif else begin
				if( dataSize NE firstDataSize ) then begin
					if(isnotSilent) then $
						print,'Error! - Data size is different from first channel''s.'
					result = -1
					goto, EXIT_PRO_1
				endif
			endelse

			;//	データ配列の型が指定されていない場合に取得 ;2013-11-15
			if( ArrayType EQ -1) then begin
				arrayType = 0
				if( valueLen le 8 ) then begin
					arrayType = 0
				endif else if( valueLen le 16 ) then begin
					arrayType = 1
				endif else if( valueLen le 32 ) then begin
					arrayType = 2
				endif else if( valueLen le 64 ) then begin
					arrayType = 5
				endif
				type_image = string(imageType)
				if( type_image EQ 'FLT32' ) then begin
					arrayType = 3
				endif else if( type_image EQ 'FLT64' ) then begin
					arrayType = 4
				endif
				if( valueLen EQ 0 ) then begin
					if( type_image EQ 'INT16' ) then begin
						arrayType = 1
					endif else if( type_image EQ 'INT32' ) then begin
						arrayType = 2
					endif else if( type_image EQ 'INT64' ) then begin
						arrayType = 5
					endif
				endif
			endif

			databuf = 0
			if( ArrayType EQ 0 ) then begin				;//	2005/12/13 Modified
				arrayLength = DataSize
				if ( arrayLength gt 0 ) then begin
					if( numOfCh NE 1 ) then databuf = BYTARR( arrayLength )
					if( numOfCh EQ 1 ) then dataArray = BYTARR( arrayLength )
				endif
			endif else if( ArrayType EQ 1) then begin	;//	2002/11/19 Modified
				arrayLength = (DataSize + 1) / 2
				if ( arrayLength gt 0 ) then begin
					if( numOfCh NE 1 ) then databuf = INTARR( arrayLength )
					if( numOfCh EQ 1 ) then dataArray = INTARR( arrayLength )
				endif
			endif else if(ArrayType EQ 2) then begin
				arrayLength = (DataSize + 3) / 4
				if ( arrayLength gt 0 ) then begin
					if( numOfCh NE 1 ) then databuf = LONARR( arrayLength )
					if( numOfCh EQ 1 ) then dataArray = LONARR( arrayLength )
				endif
			endif else if(ArrayType EQ 3) then begin
				arrayLength = (DataSize + 3) / 4
				if ( arrayLength gt 0 ) then begin
					if( numOfCh NE 1 ) then databuf = FLTARR( arrayLength )
					if( numOfCh EQ 1 ) then dataArray = FLTARR( arrayLength )
				endif
			endif else if(ArrayType EQ 4) then begin
				arrayLength = (DataSize + 7) / 8
				if ( arrayLength gt 0 ) then begin
					if( numOfCh NE 1 ) then databuf = DBLARR( arrayLength )
					if( numOfCh EQ 1 ) then dataArray = DBLARR( arrayLength )
				endif
			endif else if(ArrayType EQ 5) then begin
				arrayLength = (DataSize + 7) / 8
				if ( arrayLength gt 0 ) then begin
					if( numOfCh NE 1 ) then databuf = LON64ARR( arrayLength )
					if( numOfCh EQ 1 ) then dataArray = LON64ARR( arrayLength )
				endif
			endif else begin
				if(isnotSilent) then $
					print,'Error! - Unknown Array Data Type.'
				result = -1
				goto, EXIT_PRO_1
			endelse

			if ( arrayLength gt 0 ) then begin
				dataLength = 0LL
				if( numOfCh NE 1 ) then begin
					result = CALL_EXTERNAL( object,sym_ChData,rtd,chno,databuf,dataSize,dataLength)
				endif else begin
					result = CALL_EXTERNAL( object,sym_ChData,rtd,chno,dataArray,dataSize,dataLength)
				endelse

				if( result NE 0 ) then begin
					if(isnotSilent) then $
						print,'Error from DLL( ',sym_ChData,' )!',result,': ',retrieve_message(result)
					goto, EXIT_PRO_1
				endif

				if( 1 NE numOfCh ) then begin
				;//	ループ最初の場合、データ配列を作成
					if( loopCnt EQ 0 ) then begin
						case ArrayType of
							0	:	dataArray = BYTARR(arrayLength, numOfCh)
							1	:	dataArray = INTARR(arrayLength, numOfCh)
							2	:	dataArray = LONARR(arrayLength, numOfCh)
							3	:	dataArray = FLTARR(arrayLength, numOfCh)
							4	:	dataArray = DBLARR(arrayLength, numOfCh)
							5	:	dataArray = LON64ARR(arrayLength, numOfCh)
							else:	begin
									if(isnotSilent) then $
										print,'Error! - Unknown Array Data Type.'
									result = -1
									goto, EXIT_PRO_1
								end
						endcase

					endif
					dataArray(*, loopCnt) = databuf
					databuf = 0
				endif
			endif else begin
				dataArray = 0L
			endelse

			TotalSize = TotalSize + compSize	;

		endif else if( 3 EQ data_struct ) then begin
			result = -1
			if ( 0 NE isnFrame ) then begin
				if(isnotSilent) then $
					print,'<Error: converting to voltage or real number from frame data is not supported.>'
				goto, EXIT_PRO_1
			endif

	 		if( dataSize EQ 0LL ) then begin	;データサイズ0回避
				if(isnotSilent and NOT KEYWORD_SET(noarray) ) then $
					print,'Error! - Data Size is 0.'
				dataArray = 0L
			endif

			synNum = CALL_EXTERNAL( object,sym_ChVsynNum,rtd,chno)
			if ( 0 EQ synNum ) then begin
				if(isnotSilent) then $
					print,'<Error: converting to voltage or real number is not supported.>'
				goto, EXIT_PRO_1
			endif
			dataSize = dataSize/synNum

			;データサイズが最初のチャネルのものより大きいとエラー
			if( -1LL EQ firstDataSize ) then begin
				firstDataSize = dataSize
			endif else begin
				if( dataSize NE firstDataSize ) then begin
					if(isnotSilent) then $
						print,'Error! - Data size is different from first channel''s.'
					goto, EXIT_PRO_1
				endif
			endelse

			databuf = 0
	 		if( dataSize NE 0 ) then begin
				if( (valueLen ge 1) and (valueLen le 8)) then begin
					arrayLength = DataSize
				endif else if ( (valueLen ge 9) and (valueLen le 16) ) then begin
					arrayLength = (DataSize + 1) / 2
				endif else if ( (valueLen ge 17) and (valueLen le 32) ) then begin
					arrayLength = (DataSize + 3) / 4
				endif else if ( (valueLen ge 33) and (valueLen le 64) ) then begin
					arrayLength = (DataSize + 7) / 8
				endif else begin
					if(isnotSilent) then $
						print,'<Error: converting to voltage or real number is not supported.>'
					goto, EXIT_PRO_1
				endelse

				if ( arrayLength gt 0LL ) then begin
					dataLength = 0LL
					if( numOfCh NE 1 ) then begin
						if( volts EQ 1 ) then begin
							databuf = FLTARR( arrayLength )
						endif else  begin
							databuf = DBLARR( arrayLength )
						endelse
						result = CALL_EXTERNAL( object,sym_ChV,rtd,chno,databuf,arrayLength,dataLength,long(volts))
					endif else begin
						if( volts EQ 1 ) then begin
							dataArray = FLTARR( arrayLength )
						endif else  begin
							dataArray = DBLARR( arrayLength )
						endelse
						result = CALL_EXTERNAL( object,sym_ChV,rtd,chno,dataArray,arrayLength,dataLength,long(volts))
					endelse

					if( result NE 0 ) then begin
						if(isnotSilent) then $
							print,'Error from DLL( ',sym_ChV,' )!',result,': ',retrieve_message(result)
						goto, EXIT_PRO_1
					endif

					if( numOfCh NE 1 ) then begin
						;ループ最初の場合、データ配列を作成
						if( loopCnt EQ 0 ) then begin
							if( volts EQ 1 ) then begin
								dataArray = FLTARR(arrayLength, numOfCh)
							endif else begin
								dataArray = DBLARR(arrayLength, numOfCh)
							endelse
						endif
			 			dataArray(*, loopCnt) = databuf
						databuf = 0
					endif
				endif else begin
					dataArray = 0L
				endelse
			endif

			TotalSize = TotalSize + compSize	;
		endif else if( 2 EQ data_struct ) then begin
			result = -1
			sframe = long(1)
			eframe = long(isnFrame)
			result = CALL_EXTERNAL( object,sym_RetrieveNo ,rtd ,chno ,sframe ,eframe)
			frcount = eframe-sframe+1
			result = CALL_EXTERNAL( object,sym_FrameInfo ,rtd ,chno ,sframe ,dataSize ,ImageType ,frameX ,frameY, 2)
			if( result lt 0 ) then begin
				if(isnotSilent) then $
					print,'Error from DLL( ',sym_FrameInfo,' )!',result,': ',retrieve_message(result)
				goto, EXIT_PRO_1
			endif
	 		if( dataSize EQ 0 ) then begin	;//データサイズ0回避
				if(isnotSilent) then $
					print,'Error! - Data Size is 0.'
				dataArray = 0L
				goto, EXIT_PRO_1
			endif
			if( result eq 1 ) then begin
				ArrayType = -2;
			endif
			;//	データ配列の型が指定されていない場合に取得
			if( ArrayType EQ -1) then begin
				valueLen = dataSize/(frameX*frameY)*8
				if(valueLen le 8) then begin
					ArrayType = 0
				endif else if(valueLen le 16) then begin
					ArrayType = 1
				endif else if(valueLen le 32) then begin
					ArrayType = 2
				endif else if(valueLen le 64) then begin
					ArrayType = 5
				endif
				type_image = string(imageType)
				if( type_image EQ 'FLT32' ) then begin
					ArrayType = 3
				endif else if( type_image EQ 'FLT64' ) then begin
					ArrayType = 4
       	endif
			endif

			for frno=sframe, eframe do begin

				databuf = 0
				if( ArrayType EQ 0 ) then begin
					databuf = BYTARR( frameX,frameY )
				endif else if( ArrayType EQ 1) then begin
					databuf = INTARR( frameX,frameY )
				endif else if(ArrayType EQ 2) then begin
					databuf = LONARR( frameX,frameY )
				endif else if(ArrayType EQ 3) then begin
					databuf = FLTARR( frameX,frameY )
				endif else if(ArrayType EQ 4) then begin
					databuf = DBLARR(  frameX,frameY  )
				endif else if(ArrayType EQ 5) then begin
					databuf = LON64ARR(  frameX,frameY  )
				endif else if(ArrayType EQ -2) then begin
					databuf = BYTARR(  dataSize  )
				endif else begin
					if(isnotSilent) then $
						print,'Error! - Unknown Array Data Type.'
					result = -1
					goto, EXIT_PRO_1
				endelse
				if ( dataSize gt 0 ) then begin
					dataLength = 0LL
                databuf(0,0)=1
					result = CALL_EXTERNAL( object,sym_FrameData,rtd,chno,frno,databuf,dataSize,dataLength)
					if( result NE 0 ) then begin
						if(isnotSilent) then $
							print,'Error from DLL( ',sym_FrameData,' )!',result,': ',retrieve_message(result)
						goto, EXIT_PRO_1
					endif
					if( dataLength EQ 0 ) then begin
						if(isnotSilent) then $
							print,'Error! - Data Size is 0 at frame(',frno,').'
						dataArray = 0L
						result =-4
						goto, EXIT_PRO_1
					endif
					if( dataSize NE dataLength ) then begin
						if(isnotSilent) then $
							print,'Error! - Data size(frame=',frno,') is different from first frame''s.',format='(A,I4,A)'
						result = -1
						goto, EXIT_PRO_1
					endif
					;//	ループ最初の場合、データ配列を作成
					if( loopCnt EQ 0 ) and ( frno EQ sframe ) then begin
						case ArrayType of
							0	:	dataArray = BYTARR(frameX ,frameY ,frcount ,numOfCh)
							1	:	dataArray = INTARR(frameX ,frameY ,frcount ,numOfCh)
							2	:	dataArray = LONARR(frameX ,frameY ,frcount ,numOfCh)
							3	:	dataArray = FLTARR(frameX ,frameY ,frcount ,numOfCh)
							4	:	dataArray = DBLARR(frameX ,frameY ,frcount ,numOfCh)
							5	:	dataArray = LON64ARR(frameX ,frameY ,frcount ,numOfCh)
							-2  :   dataArray = BYTARR(dataSize,1     ,frcount ,numOfCh)
							else:	begin
										if(isnotSilent) then $
											print,'Error! - Unknown Array Data Type.'
										result = -1
										goto, EXIT_PRO_1
									end
						endcase
					endif

					dataArray(*,*,frno - sframe , loopCnt) = databuf
				endif else begin

					dataArray = 0L
				endelse

				databuf=0
			endfor
			TotalSize = TotalSize + compSize

		endif
		if N_elements(params) NE 0 or  sw_time NE 0 then begin	;// キーワードパラメータあり --------------------------------
			result = -1
			if( paramCount EQ 0 ) then begin
				if(isnotSilent) then $
					print,'Error! - There is no parameters in this data object.'
				goto, EXIT_PRO_1
			endif
			if( N_elements(params) NE 0 ) then begin
				if( loopCnt EQ 0 ) then begin
					;//	最初のチャネルの場合、パラメータ配列作成
					pset={ PARAMSET, pName:String(' ',format='(A3)'), pValue:String(' ',format='(A3)'), pType:long(0) }
					psetArray = Replicate( pset, paramCount, numOfCh )
					firstParamCount = paramCount
				endif

				if( firstParamCount lt paramCount ) then begin
					if(isnotSilent) then $
						print,'Error! - Parameter count is different from first channel''s.'
						goto, EXIT_PRO_1
				endif
			endif

			pNameBuf = strarr( paramCount )		;// for parameter name
			pValueBuf = strarr( paramCount )	;// for parameter value
			pTypeBuf = lonarr( paramCount )		;// for parameter data type

;			for pc=0,paramCount-1 do begin
;				pNameBuf(pc) =  "                                 "	;// 32 character
;				pValueBuf(pc) = "                                 "	;// 32 character
;				pTypeBuf(pc) = 0L
;			endfor

;			result = CALL_EXTERNAL( object,sym_ChParam,rtd,chno,pNameBuf,pValueBuf,pTypeBuf )
			for pc=0L,paramCount-1 do begin
				pName	= bytarr(64)
				pValue	= bytarr(128)
				pType	= 0L
				result = CALL_EXTERNAL( object,sym_ChParam,rtd,chno,pc,pName,pValue,pType)
				if( result NE 0 ) then begin
			                    break;
				endif
				pNameBuf(pc)	=string(pName)
				pValueBuf(pc)	=string(pValue)
				pTypeBuf(pc)	=pType
			endfor

			if( result NE 0 ) then begin
				if(isnotSilent) then $
					print,'Error from DLL( ',sym_ChParam,' )! ',result,' : ',retrieve_message(result)
				goto, EXIT_PRO_1
			endif
			if( N_elements(params) NE 0 ) then begin
				for pc=0,paramCount-1 do begin
					psetArray(pc, loopCnt).pName = pNameBuf(pc)
					psetArray(pc, loopCnt).pValue = pValueBuf(pc)
					psetArray(pc, loopCnt).pType = pTypeBuf(pc)
				endfor
			endif
			;----------------------------------------------------------------------
			if( sw_time NE 0 ) then begin
				DTSsource = bytarr(64)
				DTShostID = bytarr(64)
				DTSmoduleID = bytarr(64)
				DTStrgChannel = bytarr(64)
				CLKsource = bytarr(64)
				CLKhostID = bytarr(64)
				CLKmoduleID = bytarr(64)
				DTSclkChannel = bytarr(64)
				DTSuserDefine = long(0)
				timeArraySize = 0LL
				timeArrayLength = 0LL
				clockSource = bytarr(64)
				if( isDouble ) then begin
					clockCycle = double(0)
					startTiming = double(0)
					trigDelay = double(0)
				endif else begin
					clockCycle = float(0)
					startTiming = float(0)
					trigDelay = float(0)
				endelse

				result = CALL_EXTERNAL( object, sym_GetDTSinfo, rtd, chno,$
							DTSsource, DTShostID, DTSmoduleID, DTStrgChannel, $
							CLKSource, CLKhostID, CLKmoduleID, DTSclkChannel, $
							DTSuserDefine, clockSource, timeArraySize,  $
							clockCycle, trigDelay, startTiming, isDouble );
				if( result EQ 0 ) then begin
					sDTSsource = string(DTSsource)
					sDTShostID = string(DTShostID)
					sDTSmoduleID = string(DTSmoduleID)
					sCLKsource = string(CLKsource)
					sCLKhostID = string(CLKhostID)
					sCLKmoduleID = string(CLKmoduleID)
					sDTStrgChannel = string(DTStrgChannel)
					sDTSclkChannel = string(DTSclkChannel)
					if( isnotSilent ) then begin
						print,'DTS source         = '  ,sDTSsource,		format='(A,A)'
						print,'DTS host ID        = '  ,sDTShostID,		format='(A,A)'
						print,'DTS module ID      = '  ,sDTSmoduleID,	format='(A,A)'
						print,'DTS trigger ch     = '  ,sDTStrgChannel,	format='(A,A)'
						if( sDTSsource NE sCLKsource OR sDTShostID NE sCLKhostID OR sDTSmoduleID NE sCLKmoduleID ) then begin
							print,'CLK source         = '  ,sCLKsource,		format='(A,A)'
							print,'CLK host ID        = '  ,sCLKhostID,		format='(A,A)'
							print,'CLK module ID      = '  ,sCLKmoduleID,	format='(A,A)'
						endif
						print,'DTS clock ch       = '  ,sDTSclkChannel,	format='(A,A)'
						print,'DTS user define    = '  ,DTSuserDefine,	format='(A,I10)'
						print,'Time array size    = '  ,timeArraySize,format='(A,I10)'
						if( isDouble ) then begin
							print,'Cycle = ['  , clockCycle ,'] sec',format='(A,f14.10,A)'
							print,'Delay = ['  , startTiming ,'] sec',format='(A,f14.10,A)'
						endif else begin
							print,'Cycle = ['  , clockCycle ,'] sec',format='(A,f10.6,A)'
							print,'Delay = ['  , startTiming ,'] sec',format='(A,f10.6,A)'
						endelse
					endif
					if( timeArraySize EQ 0) then begin
						result = 58
					endif else if( isDouble ) then begin
						tmpTimeArray = dblarr(timeArraySize)
					endif else begin
						tmpTimeArray = fltarr(timeArraySize)
					endelse
					if( result EQ 0 ) then begin
						result = CALL_EXTERNAL( object, sym_GetDTSdata, rtd, chno,$
								tmpTimeArray, timeArraySize, timeArrayLength, isDouble)
					endif
				endif
				if( timeArraySize EQ 0 AND result EQ 0 AND N_elements(ta) NE 0 AND numOfCh GT 1) then begin
					result = 58
				endif
				if( result NE 0 ) then begin
					if( isnotSilent ) then begin
						if( result GT 0) then begin
							printRetrieve_tErrorMsg,result,IndexServer,diagName,string(DTShostID)
						endif else begin
							print,retrieve_message(result)
						endelse
					endif
					goto, EXIT_PRO_1
				endif
				if N_elements(ta) NE 0 then begin
					if( numOfCh EQ 1 ) then begin
						ta = tmpTimeArray
					endif else begin
						if( loopCnt EQ 0 ) then begin
							if(isDouble) then begin
								ta = dblarr(timeArraySize, numOfCh)
							endif else begin
								ta = fltarr(timeArraySize, numOfCh)
							endelse
							firstTimeSize = timeArraySize
						endif
						if( firstTimeSize NE timeArraySize ) then begin
							if(isnotSilent) then $
								print,'Error! - Time Araay size is different from first channel''s.'
							goto, EXIT_PRO_1
						endif

						ta(*, loopCnt) = tmpTimeArray
					endelse
				endif
				if N_elements(tp) NE 0 then begin	;// キーワードパラメータあり ------------------------------
					pset={ PARAMSET, pName:String(' ',format='(A3)'), pValue:String(' ',format='(A3)'), pType:long(0) }
					if ( loopCnt EQ 0 ) then begin
						tp = Replicate( pset, 13, numOfCh )
					endif

					tp(0, loopCnt) = { PARAMSET, 'DTSsource', 		sDTSsource, 		1 }
					tp(1, loopCnt) = { PARAMSET, 'DTShostID', 		sDTShostID, 		1 }
					tp(2, loopCnt) = { PARAMSET, 'DTSmoduleID', 	sDTSmoduleID, 		1 }
					tp(3, loopCnt) = { PARAMSET, 'TriggerCh', 		sDTStrgChannel, 	1 }
					tp(4, loopCnt) = { PARAMSET, 'CLKsource', 		sCLKsource, 		1 }
					tp(5, loopCnt) = { PARAMSET, 'CLKhostID', 		sCLKhostID, 		1 }
					tp(6, loopCnt) = { PARAMSET, 'CLKmoduleID', 	sClkmoduleID, 		1 }
					tp(7, loopCnt) = { PARAMSET, 'ClockCh', 		sDTSclkChannel, 	1 }
					tp(8, loopCnt) = { PARAMSET, 'ClockSource', 	string(clockSource), 		1 }
					tp(9, loopCnt) = { PARAMSET, 'TimeArraySize', 	string(timeArraySize), 	7 }
					if( isDouble ) then begin
						tp(10, loopCnt) = { PARAMSET, 'ArrayDataType',		'Double',	 		1 }
						tp(11, loopCnt) = { PARAMSET, 'ClockCycle(sec)',	string(clockCycle),	6 }
						tp(12, loopCnt) = { PARAMSET, 'StartTiming(sec)',	string(startTiming),6 }
					endif else begin
						tp(10, loopCnt) = { PARAMSET, 'ArrayDataType',		'Float',	 		1 }
						tp(11, loopCnt) = { PARAMSET, 'ClockCycle(sec)',	string(clockCycle), 5 }
						tp(12, loopCnt) = { PARAMSET, 'StartTiming(sec)',	string(startTiming),5 }
					endelse
				endif
			endif	; --end sw_time

		endif
		loopCnt = loopCnt+1
	ENDFOR
	ENDFOR

	if N_elements(params) NE 0 then params = psetArray

	if(isnotSilent and NOT KEYWORD_SET(noarray) ) and ( TotalSize NE 0LL ) then begin
		print,' '								; # @20021216
		print,'>>Total Size = ',TotalSize		; # @20021216
	endif

	result = 0
EXIT_PRO_1:
	if( result NE 0 ) then begin
		if N_elements(tp) NE 0 then begin
			tp = 0
		endif
		if N_elements(ta) NE 0 then begin
			ta = 0
		endif
		if N_elements(params) NE 0 then begin
			params = 0
		endif
		dataArray = 0
	endif
	code = result
	if( rtd gt 0 ) then	ret = retrieve_close(rtd)
	rtd = CALL_EXTERNAL( object, sym_IndexCntl, 0,VALUE=[1])
	return
END

FUNCTION signed8ToInt, src_array, array_size
	np = n_params()
	if ( np NE 1 and np NE 2 ) then begin
		print, 'Usage: dest_array = signed8ToInt( src_array [,size]) '
		retall
	endif

	src_len = N_ELEMENTS(src_array)
	if( np EQ 1 ) then begin
		array_size = src_len
	endif
	if( src_len < array_size ) then array_size = src_len

	src_type = size(src_array,/type)
	if( 1 EQ src_type ) then begin
		if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
		else object = !Retrieve + '/bin/retrieve.dll'
		sym_copy2int  = 'IdlIntegerFromByte'

		dest_array = INTARR(array_size)

		result = CALL_EXTERNAL( object, sym_copy2int, dest_array, src_array, array_size)
		if( result EQ 0 ) then begin
			return,dest_array
		endif
		print,'Error from DLL( ',sym_copy2int,' )!',result,': ',retrieve_message(result)
	endif
	retall
END

PRO ChangeSite, siteName,code,silent=silent

	if ( n_params(0) EQ 0 ) then begin
		print, 'Usage:'
		print, ' ChangeSite, siteName, [code]'
		print, ' '
		print, ' Input Arguements:'
		print, '   > siteName   -- site name'
		print, ' Output Parameters:'
		print, '   > code       -- result code'
		print, ' '
		return
	endif
	stype=size(siteName)
	if ( stype(1) NE 7 ) then begin
		print, 'Usage:'
		print, ' ChangeSite, siteName, [code]'
		print, ' '
		print, ' Input Arguements:'
		print, '   > siteName   -- site name (''lhd'',...) '
		print, ' Output Parameters:'
		print, '   > code       -- result code'
		print, ' '
		return
	endif

	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'
	sym_changeSite  = 'IdlRetrieveChangeSite'
	env_str = bytarr(128)
	result = CALL_EXTERNAL( object, sym_changeSite,siteName,env_str,VALUE=[1,0] )
	if( result NE 0 ) then begin
		if(isnotSilent) then $
			print,'Error from DLL( ',sym_changeSite,' )!',result,': ',retrieve_message(result)
	endif else begin
		setenv,string(env_str)
	endelse
    code = result
END

PRO CurrentSite
	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'
	site = CALL_EXTERNAL( object,  'IdlRetrieveGetSite', /S_Value)
	print,site
END

;//////////////////// パラメータ取得・変換ファンクション ////////////////////

;// =======================================
;// 	FUNCTION　getParamLong
;//		32ビット符号付整数への変換
;// =======================================

FUNCTION getParamLong,paramName,params,channelNumber

np = n_params()
if ( np lt 2 ) or ( np gt 3 ) then begin
	print, '  << Usage: longValue = getParamLong( paramName, keyParams, (chanNumber) ) >>'
	print, '	   The call must have 2 or 3 parameters!'
	print, '		(1) parameter name (''clockSpeed'',.., etc.)'
	print, '		(2) keyword parameter( always required )'
	print, '		(3) channel number( if necessary )'
	retall
endif

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if (np EQ 2) and (sz(0) EQ 2) then begin
	print,"You need the channel_number argument for multi-channel retrieved parameters."
	print, '  << Usage: longValue = getParamLong( paramName, keyParams, chanNumber ) >>'
	print,"Abort execution."
	retall
endif

if np EQ 2 then begin					; for 1 channel
	for pc=0,paramCount-1 do begin
		if params(pc).pName EQ paramName then begin
			return, long(params(pc).pValue)
		endif
	endfor
endif else begin							; for multi channel
	cc=channelNumber-1
	for pc=0,paramCount-1 do begin
		if params(pc,cc).pName EQ paramName then begin
			return, long(params(pc,cc).pValue)
		endif
	endfor
endelse

return,"Error - parameter not found!"
end

;// =======================================
;// 	FUNCTION　getParamInt
;//		16ビット符号付整数への変換
;// =======================================

FUNCTION getParamInt,paramName,params,channelNumber

np = n_params()
if ( np lt 2 ) or ( np gt 3 ) then begin
	print, '  << Usage: intValue = getParamInt( paramName, keyParams, (chanNumber) ) >>'
	print, '	   The call must have 2 or 3 parameters!'
	print, '		(1) parameter name (''clockSpeed'',.., etc.)'
	print, '		(2) keyword parameter( always required )'
	print, '		(3) channel number( if necessary )'
	retall
endif

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if (np EQ 2) and (sz(0) EQ 2) then begin
	print,"You need the channel_number argument for multi-channel retrieved parameters."
	print, '  << Usage: intValue = getParamInt( paramName, keyParams, chanNumber ) >>'
	print,"Abort execution."
	retall
endif

if np EQ 2 then begin
	for pc=0,paramCount-1 do begin
		if params(pc).pName EQ paramName then begin
			return, fix(params(pc).pValue)
		endif
	endfor
endif else begin
	cc=channelNumber-1
	for pc=0,paramCount-1 do begin
		if params(pc,cc).pName EQ paramName then begin
			return, fix(params(pc,cc).pValue)
		endif
	endfor
endelse

return,"Error - parameter not found!"
end

;// =======================================
;// 	FUNCTION　getParamFloat
;//		32ビット単精度実数への変換
;// =======================================

FUNCTION getParamFloat,paramName,params,channelNumber

np = n_params()
if ( np lt 2 ) or ( np gt 3 ) then begin
	print, '  << Usage: floatValue = getParamFloat( paramName, keyParams, (chanNumber) ) >>'
	print, '	   The call must have 2 or 3 parameters!'
	print, '		(1) parameter name (''clockSpeed'',.., etc.)'
	print, '		(2) keyword parameter( always required )'
	print, '		(3) channel number( if necessary )'
	retall
endif

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if (np EQ 2) and (sz(0) EQ 2) then begin
	print,"You need the channel_number argument for multi-channel retrieved parameters."
	print, '  << Usage: floatValue = getParamFloat( paramName, keyParams, chanNumber ) >>'
	print,"Abort execution."
	retall
endif

if np EQ 2 then begin
	for pc=0,paramCount-1 do begin
		if params(pc).pName EQ paramName then begin
			return, float(params(pc).pValue)
		endif
	endfor
endif else begin
	cc=channelNumber-1
	for pc=0,paramCount-1 do begin
		if params(pc,cc).pName EQ paramName then begin
			return, float(params(pc,cc).pValue)
		endif
	endfor
endelse

return,"Error - parameter not found!"
end

;// =======================================
;// 	FUNCTION　getParamDouble
;//		64ビット倍精度実数への変換
;// =======================================

FUNCTION getParamDouble,paramName,params,channelNumber

np = n_params()
if ( np lt 2 ) or ( np gt 3 ) then begin
	print, '  << Usage: doubleValue = getParamDouble( paramName, keyParams, (chanNumber) ) >>'
	print, '	   The call must have 2 or 3 parameters!'
	print, '		(1) parameter name (''clockSpeed'',.., etc.)'
	print, '		(2) keyword parameter( always required )'
	print, '		(3) channel number( if necessary )'
	retall
endif

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if (np EQ 2) and (sz(0) EQ 2) then begin
	print,"You need the channel_number argument for multi-channel retrieved parameters."
	print, '  << Usage: doubleValue = getParamDouble( paramName, keyParams, chanNumber ) >>'
	print,"Execution aborted."
	retall
endif

if np EQ 2 then begin
	for pc=0,paramCount-1 do begin
		if params(pc).pName EQ paramName then begin
			return, double(params(pc).pValue)
		endif
	endfor
endif else begin
	cc=channelNumber-1
	for pc=0,paramCount-1 do begin
		if params(pc,cc).pName EQ paramName then begin
			return, double(params(pc,cc).pValue)
		endif
	endfor
endelse

return,"Error - parameter not found!"
end

;// =======================================
;// 	FUNCTION　getParamString
;//		文字列型への変換
;// =======================================

FUNCTION getParamString,paramName,params,channelNumber

np = n_params()
if ( np lt 2 ) or ( np gt 3 ) then begin
	print, '  << Usage: strValue = getParamString( paramName, keyParams, (chanNumber) ) >>'
	print, '	   The call must have 2 or 3 parameters!'
	print, '		(1) parameter name (''clockSpeed'',.., etc.)'
	print, '		(2) keyword parameter( always required )'
	print, '		(3) channel number( if necessary )'
	retall
endif

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if (np EQ 2) and (sz(0) EQ 2) then begin
	print,"You need the channel_number argument for multi-channel retrieved parameters."
	print, '  << Usage: strValue = getParamString( paramName, keyParams, chanNumber ) >>'
	print,"Abort execution."
	retall
endif

if np EQ 2 then begin					; for 1 channel
	for pc=0,paramCount-1 do begin
		if params(pc).pName EQ paramName then begin
			return, string(params(pc).pValue)
		endif
	endfor
endif else begin							; for multi channel
	cc=channelNumber-1
	for pc=0,paramCount-1 do begin
		if params(pc,cc).pName EQ paramName then begin
			return, string(params(pc,cc).pValue)
		endif
	endfor
endelse

return,"Error - parameter not found!"
end

;// =======================================
;// 	PROCEDURE printParam
;//		パラメータ情報の一覧表示
;//	[制限]パラメータ値は16文字のみ表示
;// =======================================

PRO printParam,params

;// defined dataType for paramType
dataType = strarr(8)
dataType(0) = "Undefined"
dataType(1) = "String"
dataType(2) = "Byte"
dataType(3) = "Short"
dataType(4) = "Integer"
dataType(5) = "Float"
dataType(6) = "Double"
dataType(7) = "Int64"

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if n_params() EQ 1 then begin
	print,"parameter count = ",paramCount,format='(A,I3)'
	print,"channel   count = ",channelCount,format='(A,I3)'
	print,"Note: Parameter value is shown first 16 characters."
	print," "
	print,"CH","Name","Value","Type",format='(A3,A32,A28,A9)'
	for cc=0,channelCount-1 do begin
		for pc=0,paramCount-1 do begin
			paramName = params(pc,cc).pName
			paramValue = params(pc,cc).pValue
			paramType = params(pc,cc).pType
			print,cc+1,paramName,paramValue,dataType(paramType),format='(I3,A32,A28,A9)'
		endfor
		print," "
	endfor
endif else begin
	print, '  << Usage: printParam, keyParams >>'
	print, '	   The call must have 1 parameter!'
	print, '		(1) keyword parameter( always required )'
	retall
endelse

return
end

;// =======================================
;// 	FUNCTION　getParamLong64
;//		64ビット符号付整数への変換
;// =======================================

FUNCTION getParamLong64,paramName,params,channelNumber

np = n_params()
if ( np lt 2 ) or ( np gt 3 ) then begin
	print, '  << Usage: long64Value = getParamLong64( paramName, keyParams, chanNumber ) >>'
	print, '	   The call must have 2 or 3 parameters!'
	print, '		(1) parameter name (''clockSpeed'',.., etc.)'
	print, '		(2) keyword parameter( always required )'
	print, '		(3) channel number( if necessary )'
	retall
endif

sz = size(params)
paramCount = sz(1)
if sz(0) EQ 1 then begin
	channelCount = 1
endif else begin
	channelCount = sz(2)
endelse

if (np EQ 2) and (sz(0) EQ 2) then begin
	print,"You need the channel_number argument for multi-channel retrieved parameters."
	print, '  << Usage: long64Value = getParamLong64( paramName, keyParams, chanNumber ) >>'
	print,"Abort execution."
	retall
endif

if np EQ 2 then begin
	for pc=0,paramCount-1 do begin
		if params(pc).pName EQ paramName then begin
			return, LONG64(params(pc).pValue)
		endif
	endfor
endif else begin
	cc=channelNumber-1
	for pc=0,paramCount-1 do begin
		if params(pc,cc).pName EQ paramName then begin
			return, LONG64(params(pc,cc).pValue)
		endif
	endfor
endelse

return,"Error - parameter not found!"
end


FUNCTION cnvUYVYtoRGB, yuv_array, scA64070gc=sc
	np = n_params()
	if ( np NE 1 and np NE 2 ) then begin
		print, 'Usage: rgb_array = cnvUYVYtoRGB( yuv_array [,/scA64070gc]) '
		print, ' info: tvscl, rgb_array, /true, /order'
		retall
	endif
	src_ss = size(yuv_array)
	src_dim = src_ss(0)
	if( 0 EQ src_dim ) then begin
		print, 'YUV ARRAY must be INT ARRAY or BYTE ARRAY.'
		retall
	endif
	src_type = src_ss(src_dim+1)
	if( 1 EQ src_type ) then begin
		src_blen = src_ss(src_dim+2);
		dst_ss=LONARR(src_dim+4)
		if( 2 EQ src_ss(1) ) then begin
			dst_ss(0) = src_dim;
			dst_ss(1) = 3
			dst_ss(2:src_dim) = src_ss(2:src_dim)
			dst_ss(src_dim+1) = 1
			dst_ss(src_dim+2) = src_ss(src_dim+2)/2*3
		endif else begin
			dst_ss(0) = src_dim+1;
			dst_ss(1) = 3
			dst_ss(2:src_dim+1) = src_ss(1:src_dim)
			dst_ss(2) = dst_ss(2)/2
			dst_ss(src_dim+2) = 1
			dst_ss(src_dim+3) = src_ss(src_dim+2)/2*3
		endelse
	endif else if ( 2 EQ src_type ) then begin
		src_blen = src_ss(src_dim+2)*2;
		dst_ss=LONARR(src_dim+4)
		dst_ss(0) = src_dim+1;
		dst_ss(1) = 3
		dst_ss(2:src_dim+1) = src_ss(1:src_dim)
		dst_ss(src_dim+2) = 1
		dst_ss(src_dim+3) = src_ss(src_dim+2)*3
	endif else begin
		print, 'YUV ARRAY must be INT ARRAY or BYTE ARRAY.'
		retall
	endelse
	
	model=0
	if (KEYWORD_SET(sc)) then begin
		model=1
	endif

	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'

	rgb_array = make_array(size=dst_ss)

	result = CALL_EXTERNAL( object, 'IdlRGBfromYUV422', rgb_array, yuv_array, src_blen, model)
	return,rgb_array
END
FUNCTION cnvYUY2toRGB, yuv_array
	np = n_params()
	if ( np NE 1 ) then begin
		print, 'Usage: rgb_array = cnvYUY2toRGB( yuv_array) '
		print, ' info: tvscl, rgb_array, /true, /order'
		retall
	endif
	src_ss = size(yuv_array)
	src_dim = src_ss(0)
	if( 0 EQ src_dim ) then begin
		print, 'YUV ARRAY must be INT ARRAY or BYTE ARRAY.'
		retall
	endif
	src_type = src_ss(src_dim+1)
	if( 1 EQ src_type ) then begin
		src_blen = src_ss(src_dim+2);
		dst_ss=LONARR(src_dim+4)
		if( 2 EQ src_ss(1) ) then begin
			dst_ss(0) = src_dim;
			dst_ss(1) = 3
			dst_ss(2:src_dim) = src_ss(2:src_dim)
			dst_ss(src_dim+1) = 1
			dst_ss(src_dim+2) = src_ss(src_dim+2)/2*3
		endif else begin
			dst_ss(0) = src_dim+1;
			dst_ss(1) = 3
			dst_ss(2:src_dim+1) = src_ss(1:src_dim)
			dst_ss(2) = dst_ss(2)/2
			dst_ss(src_dim+2) = 1
			dst_ss(src_dim+3) = src_ss(src_dim+2)/2*3
		endelse
	endif else if ( 2 EQ src_type ) then begin
		src_blen = src_ss(src_dim+2)*2;
		dst_ss=LONARR(src_dim+4)
		dst_ss(0) = src_dim+1;
		dst_ss(1) = 3
		dst_ss(2:src_dim+1) = src_ss(1:src_dim)
		dst_ss(src_dim+2) = 1
		dst_ss(src_dim+3) = src_ss(src_dim+2)*3
	endif else begin
		print, 'YUV ARRAY must be INT ARRAY or BYTE ARRAY.'
		retall
	endelse
	
	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'

	rgb_array = make_array(size=dst_ss)

	result = CALL_EXTERNAL( object, 'IdlRGBfromYUY2', rgb_array, yuv_array, src_blen)
	return,rgb_array
END
