function dst = bgrx2rgb(src_ptr, w, h, verbose)
% Convert BGRx image format to RGB, three plane of matlab(h-w-3)
%   dst = bgrx2rgb(src_ptr, w, h, verbose)
%
% Last update : 2012-05-11
%
% See also
%     imshow

if ~exist('verbose','var')
    verbose=true;
end
liblabcom = 'librttrans';
if ~loadLibLabcom( liblabcom, verbose )
    return;
end
dst_ptr = libpointer('uint8Ptr',zeros(h,w,3,'uint8'));
calllib( 'librttrans', 'LRTbgrx2rgb4matlab', dst_ptr, src_ptr, w,h);
dst = reshape(dst_ptr.Value,h,w,3);

end
