function frame_memcopy(dst_ptr, startp, endp, src_ptr, src_len, el_bytes, verbose)
%   memory copy
%   frame_memcopy(dst_ptr, startp, endp, src_ptr, src_len, el_bytes, verbose)
%
% Last update : 2020-05-20
%

% Caution: Using 'size_t' type instead of 'int64_t' type results in abnormal processing. 
% DllClass	void LRTmemcpy(void *dst, int64_t d_stt, int64_t d_end, void* src, int64_t len);
%
if ~exist('verbose','var')
    verbose=true;
end
liblabcom = 'librttrans';
if ~loadLibLabcom( liblabcom, verbose )
    return;
end

calllib( 'librttrans', 'LRTmemcpy', dst_ptr, (startp-1)*el_bytes+1, endp*el_bytes, src_ptr, src_len*el_bytes);
end
