function mes = retrieve_tMessage( code, func_name )
%
%   mes = retrieve_tMessage( code , func_name )
%
% Last update : 2012-07-31
%
% See also
%     retrieve_t

if nargout == 1
    mes ='';
end
if nargin < 1 
   disp('Input argument is short.');
   disp('Type "help retrieve_tMessage".');
   return;
end

ip = inputParser;
ip.KeepUnmatched = true;

ip.addRequired('code', @(x)isnumeric(x) && isscalar(x) );
ip.parse( code );

if nargout < 1
    tmes = retrieve_t_mes( code );
    if nargin < 2 || ~ischar(func_name)
        fprintf('Error ! %d : %s\n', code, tmes );
    else
        fprintf('Error from DLL( %s ) ! %d : %s\n', func_name, code, tmes );
    end
else
    mes = retrieve_t_mes( code );
end
end

function mes = retrieve_t_mes( code )
% Convert code to a message for retrieve_t library. 
%   mes = retrieve_t_mes( code )
%
%ip = inputParser;
%ip.KeepUnmatched = true;
%
%ip.addRequired('code', @(x)isnumeric(x) && isscalar(x) );
%ip.parse( code );

switch code
    case 24
		mes = 'Fail to connect Index Server !';
    case 25
		mes = 'Fail to connect Trans Server !';
    case 29
		mes = 'Index protocole version disagreement!';
    case 30
		mes = 'Arc shot data retrieve on data base but not found!';
    case 31
		mes = 'Socket time out!';
    case 32
		mes = 'Trans protocole version disagreement!';
    case 33
		mes = 'Fail to get Data Location from Index Server!';
    case 34
		mes = 'Fast channel number within extent!';
    case 35
		mes = 'Last channel number within extent!';
    case 37
		mes = 'Arc shot data retrieve on data base but not found!(Abnomal porosess of Transd)';
    case 42
		mes = 'Data describe be mistaken for attribute!';
    case 54
		mes = 'No DTS link information, then use dummy data!';
    case 56
		mes = 'DTS host not found!';
	case 57
		mes = 'Old data (Shot#<56221) have no DTS information it its parameters, then use retrieve_t !';
    case 10
		mes = 'Wrong Parameter.';
    case 11
		mes = 'Wrong Parameter Numbers.';
    case -1
        mes = 'Illegal Channel number.';
    case -2
        mes = 'Illegal argument.';
    case -9
        mes = 'Cannot load shard library.';
    otherwise
        mes = ['Illegal code ' num2str(code)];
end
end




