function dst = yuv2rgb(src_ptr, w, h, yuv_type, verbose)
% Convert YUV image format to RGB, three plane of matlab(h-w-3)
%   dst = yuv2rgb(src_ptr, w, h, yuv_type,verbose)
%
% Last update : 2020-05-20
%
% See also
%     imshow

if ~exist('verbose','var')
    verbose=true;
end
liblabcom = 'librttrans';
if ~loadLibLabcom( liblabcom, verbose )
    return;
end
dst_ptr = libpointer('uint8Ptr',zeros(h,w,3,'uint8'));
calllib( 'librttrans', 'LRTyuv2rgb4matlab', dst_ptr, src_ptr, w,h , yuv_type);
dst = reshape(dst_ptr.Value,h,w,3);

end
