;// RETRIEVE_t procedure for PV-WAVE ( with retrieve.dll )
;//					Copyright 2003-2012,  NIFS LABCOM
;//	Auther: Masaki Ohsuna
;//
;//	Modification Histories
;//	2003/09/05(Ohsuna M.)	Retrieve_t,Retrieve_td を追加
;//	2003/09/16(Ohsuna M.)	WEモジュールへの対応
;//	2003/09/19(Ohsuna M.)	Retrieve_t WEモジュールのプリサンプリング収集に対応
;//	2008/05/20(Ohsuna M.)	SamplingInterval,PreSampleの扱いに関するバグ修正
;//	2008/09/03(Ohsuna M.)	retrieve_t  FPGA DTSへの対応，クロックとトリガが別々のDTSの場合への対応
;//	2008/10/24(Ohsuna M.)	/silentモードの追加
;//	2009/11/17(Ohsuna M.)	/doubleモードの追加
;//	2010/03/17(Ohsuna M.)	Paramキーワード追加r
;//	2010/10/01(Ohsuna M.)	デモジュレータの直接指定によるパラメータ取得機能追加
;//	2010/12/17(Ohsuna M.)	マルチチャンネル指定の有効化
;//	2011/05/12(Ohsuna M.)	rerieve パラメータからの時間軸情報取得機能追加
;// 2011/06/13(Ohsuna M.)   Ver.15.0.0 x86 x86_64 インストーラ統合
;//	2011/08/04(Ohsuna M.)	retrieve_t修正(コマンドライン版及びWE7562の取扱いについて)
;//	2011/08/28(Ohsuna M.)	retrieve_t修正(データ未出現時のエラー処理バグ修正とWAITモード追加)
;//	2012/07/31(Imazu S.)	Ver.16.0.0 
;//							サブショット番号の対応、チャネル番号の指定拡張,retrieve.dll更新
;// 2012/09/03(Imazu S.)  BUG-FIX 'Array Size is Zero!'
;// 2015/11/01(Imazu S.)  UPDATE printRetrieve_tErrorMsg

PRO printRetrieve_tErrorMsg,errcode,IndexServer,diagName,DTShost
	mes='';
	if( errcode eq 10 ) then begin
		mes='Invalid Value in Parameters!'
	endif else if( errcode eq 11 ) then begin
		mes='Wrong Number of Parameters!'
	endif else if( errcode eq 18 ) then begin
		mes='A length variable is overrange on INT_MAX.'
	endif else if( errcode eq 20 ) then begin
		mes='Memory allocation error!'
	endif else if( errcode eq 24 ) then begin
		mes='Fail to connect Index Server '+string(IndexServer)+'!'
	endif else if( errcode eq 25 ) then begin
		mes='Fail to connect Trans Server '+string(DTShost)+'!'
	endif else if( errcode eq 29 ) then begin
		mes='Index protocole version disagreement !'
	endif else if( errcode eq 30 ) then begin
		mes='Arc shot data retrieve on data base but not found!'
	endif else if( errcode eq 31 ) then begin
		mes='Socket time out !'
	endif else if( errcode eq 32 ) then begin
		mes='Trans protocole version disagreement!'
	endif else if( errcode eq 33 ) then begin
		mes='Fail to get Data Location from Index Server!'
	endif else if( errcode eq 34 ) then begin
		mes='Fast channel number within extent!'
	endif else if( errcode eq 35 ) then begin
		mes='Last channel number within extent!'
	endif else if( errcode eq 36 ) then begin
		mes='Can not extract of compressed data!'
	endif else if( errcode eq 37 ) then begin
		mes='Arc shot data retrieve on data base but not found ! (Abnomal porosess of Transd)'
	endif else if( errcode eq 40 ) then begin
		mes='Arc shot channel data transed error!'
	endif else if( errcode eq 42 ) then begin
		mes='Data describe be mistaken for attribute!'
	endif else if( errcode eq 53 ) then begin
		mes='Invalid DTS Information !'
	endif else if( errcode eq 54 ) then begin
		mes='No DTS link information !'
	endif else if( errcode eq 55 ) then begin
		mes='No diag name in database ['+string(diagName)+']!'
	endif else if( errcode eq 56 ) then begin
		mes='DTS host ID( '+strtrim(string(DTShost),2)+' ) is not found!'
	endif else if( errcode eq 57 ) then begin
		mes='Old data (Shot#<56221) have no DTS information it its parameters, then use retrieve_t!'
	endif else if( errcode eq 58 ) then begin
		mes='Array Size is Zero!'
	endif else if( errcode eq 62 ) then begin
		mes='DTS host ID( '+strtrim(string(DTShost),2)+' ) is not found!(CLOCK)'
	endif else if( errcode eq 63 ) then begin
		mes='No DTS link information! (CLOCK)'
	endif
	print,mes,' (Error code:'+ strtrim(string(errcode),2)+')'
END
PRO retrieve_t,diagName,shotNumber,subShotNumber,channelNumber,timeArray,code,param=params,silent=silent,double=double,wait=wait,timeout=wait_sec
	code=0
	if( (n_params( 0 ) lt 5) or (n_params( 0 ) gt 11) ) then begin
		print, 'Usage:'
		print, '  retrieve_t,diagName,shotNumber,subShotNumber,channelNumber,timeArray[,param=keyParams][,/silent][,/double][,/wait[,timeout=WaitSec]]'
		print, ' '
		print, 'Input Parameters:'
		print, '  < diagName      - Diagnostics name (''Magnetics'',.., etc.)'
		print, '  <                or DTS name (''DTS:VME01:DMOD1'',.., etc.)'
		print, '  < shotNumber    - Shot number'
		print, '  < subShotNumber - Sub shot number'
		print, '  < channelNumber - Channel number(s) (e.g. ''1,5,7-11'',''1,5,7:11'',''0''=all)'
		print, '                  or a signal tag name (e.g. ''sig-tag1'') '
		print, '  < /silent         - no display without error message'
		print, '  < /double         - return time array in double type'
		print, '  < /wait           - waiting data mode.'
		print, '  < timeout=WaitSec - time for waiting data. second unit. default 180'
		print, 'Output Parameters:'
		print, '  > timeArray       - Time array'
		print, '  > param=keyParams - Returned parameter (option)'
		print, '                      (keyParams must be pre-defined, i.e. keyParams=1)'
		print, ' '
		code=-1
		retall
	endif

	;// diagName チェック　先頭4文字が 'DTS:'の場合にDTSパラメータ取得へ
	chkstr = strsplit(diagName, ':')
	schkstr = size(chkstr)
	if( chkstr(0) eq 'DTS' AND schkstr(1) gt 1 ) then begin
		if( schkstr(1) eq 2 ) then begin
			dtsname = chkstr(1)
		endif else if( schkstr(1) gt 2 ) then begin
			dtsname = chkstr(1)+':'+chkstr(2)
		endif
		retrieve_dts,dtsname,shotNumber,subShotNumber,channelNumber,timeArray,code,param=params,silent=silent,double=double
		return
	endif
	
	if( !version.arch eq 'x86_64' or !version.arch eq 'x64') then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'

	wait_time_sec=long(0)
	if (KEYWORD_SET(wait)) then begin
		if (KEYWORD_SET(wait_sec)) then begin
			wait_time_sec = long(wait_sec)
		endif else begin
			wait_time_sec = long(180);
		endelse
	endif

	code = 0
	Server = bytarr(32)
	IndexServer = getenv('INDEXSERVERNAME')
	AShot_Number = long( shotNumber )
	ASub_Shot_Number = fix( subShotNumber )
	Shot_Number = long(0)
	Sub_Shot_Number = long(0)
	LastCh = long(0)

	DTSsource = bytarr(128)
	DTShostID = bytarr(128)
	DTSmoduleID = bytarr(128)
	DTStriggerChannel = fix(0)
	DTSclockChannel = fix(0)
	DTSuserDefine = long(0)
	DTStimeArraySize = long(0)
	clockSource = bytarr(128)
	PreSampling = long(0)
	SampInterval = long(0)
	ClkDTSid = long(0)
	
	ClkDTSmodule = bytarr(128)
	bufDTStrgChannel = bytarr(128)
	CLKsource = bytarr(128)
	CLKhostID = bytarr(128)
	CLKmoduleID = bytarr(128)
	bufDTSclkChannel = bytarr(128)
	bufIntClock = bytarr(128)
	bufSampInterval = bytarr(128)
	bufPreSamp = bytarr(128)
	bufLastCount = bytarr(128)
	
	if( IndexServer eq '' ) then begin
		setenv,'INDEXSERVERNAME=DASINDEX'
		IndexServer = getenv('INDEXSERVERNAME')
	endif

	;--	channel decode
	signal_name = 0
	chs_cnt = channel_decode( channelNumber, st_recs, en_recs)
	if( chs_cnt le 0 ) then begin
		ctype = size(channelNumber)
		if( chs_cnt eq 0 AND ctype(0) eq 0 AND ctype(1) eq 7 ) then begin
			chs_cnt = 1
			st_recs = 1
			en_recs = 1
			signal_name = 1
		endif else begin
			if( NOT KEYWORD_SET(silent)) then $
				print,'<Error: Illegal channel number!>'
				code = -1
			return
		endelse
	endif

	;//-------------------------------------------
	sym_IndexCntl = 'PvwIndexNoClosing'
	rtd = LINKNLOAD( object, sym_IndexCntl, 1)
	sym_Open = 'PvwRetrieveOpen'
	rtd = LINKNLOAD( object, sym_Open, diagName, IndexServer,$
				AShot_Number, ASub_Shot_Number, wait_time_sec)
	if( rtd lt 0 ) then begin
		if( NOT KEYWORD_SET(silent)) then $
			print,'Error from DLL( ',sym_Open,' )!',rtd,': ',retrieve_message(rtd)
		result = rtd
	endif else begin
		YY = fix(0)
		MM = fix(0)
		DD = fix(0)
		hh = fix(0)
		ms = fix(0)
		ss = fix(0)
		manageVersion = bytarr(256)
		comment = bytarr(256)
		commentsize = long(256)
		rtn_server = bytarr(256)
		sym_ShotInfo = 'PvwRetrieveShotInfo'
		result = LINKNLOAD( object, sym_ShotInfo, rtd, LastCh,$
			YY ,MM ,DD ,hh ,ms ,ss ,manageVersion ,comment ,commentsize, rtn_server )
		if( result lt 0 ) then begin
			if( NOT KEYWORD_SET(silent)) then $
				print,'Error from DLL( ',sym_ShotInfo,' )!',result,': ',retrieve_message(result)
		endif
	endelse
	if( result ne 0 ) then begin
		timeArray = 0L
		goto, EXIT_PRO_1
	endif
	numOfCh = 0
	for i=0, chs_cnt-1 do begin
		if( st_recs(i) eq 0 AND en_recs(i) eq 0 ) then begin
			st_recs(i)=1
			en_recs(i)=LastCh
		endif
		if( en_recs(i) gt LastCh ) OR ( st_recs(i) gt LastCh ) OR $
	  	( en_recs(i) le 0 ) OR ( st_recs(i) le 0 ) then begin
			numOfCh = 0
	  		goto, FOR_BLK_1
		endif
		if( st_recs(i) le en_recs(i) ) then begin
	 		numOfCh = numOfCh + ( en_recs(i) - st_recs(i) + 1)
		endif else begin
			numOfCh = numOfCh + ( st_recs(i) - en_recs(i) + 1)
		endelse
	endfor
FOR_BLK_1:
	if(numOfCh le 0) then begin
		if( NOT KEYWORD_SET(silent)) then $
			print,'<Error: Illegal channel number!>'
		result = -1
		goto, EXIT_PRO_1
	endif
	
	if( signal_name eq 0 ) then begin
		type_channel =long(2)	;// short
	endif else begin 
		type_channel =long(0)	;// signal_name
	endelse
	
	real_channel = long(0)
	LastCount = long(0)
	
	sym_GetDTSinfo = 'PvwRetrieveGetDTSinfox'
	sym_GetDTSinfoR = 'PvwRetrieveGetDTSinfoFromRetrieve'
	sym_GetDTSdataR = 'PvwRetrieveGetDTSdatax2'
	if( KEYWORD_SET(double)) then begin
		isDouble = 1L
	endif else begin
		isDouble = 0L
	endelse
	if( KEYWORD_SET(silent)) then begin
		isSilent = fix(1)
	endif else begin
		isSilent = fix(0)
	endelse
	if( AShot_Number lt 56221L ) then begin
		needDTSlink = long(0)
	endif else begin
		needDTSlink = long(1)
	endelse
	
	if( NOT KEYWORD_SET(silent) ) then begin
		print,'---DTS Infomation---'
		print,'Index Server Name  = '  ,string(IndexServer),format='(A,A)'
		print,'Shot Number        = '  ,AShot_Number       ,format='(A,I10)'
		print,'Sub Shot Number    = '  ,ASub_Shot_Number   ,format='(A,I10)'
	endif
	
	loopCnt = 0
	FOR x=0,(chs_cnt-1) DO BEGIN
		step = 1
		if( st_recs(x) gt en_recs(x) ) then step = -1
	; tch(short)
		FOR tch=st_recs(x), en_recs(x), step DO BEGIN
			if( NOT KEYWORD_SET(silent) ) then begin
				if( signal_name eq 0 ) then begin
					print,'Channel Number     = '  ,tch  ,format='(A,I5)'
				endif else begin
					print,'Channel Number     = '  ,channelNumber  ,format='(A,A)'
				endelse
			endif
			resukt = 0
			if( AShot_Number lt 56221L and signal_name eq 0 ) then begin
				result = LINKNLOAD( object, sym_GetDTSinfo, diagName,$
					AShot_Number, ASub_Shot_Number, tch, tch, IndexServer,$
					DTSsource, DTShostID, DTSmoduleID, DTStriggerChannel,$
					DTSclockChannel, DTSuserDefine, DTStimeArraySize,$
					clockSource, PreSampling, SampInterval, ClkDTSid,ClkDTSmodule)
				if( result eq 0 ) then begin
					CLKsource = DTSsource
					CLKhostID = DTShostID
					CLKmoduleID = DTSmoduleID
					bufDTStrgChannel(0:7) = byte(string(DTStriggerChannel))
					bufDTSclkChannel(0:7) = byte(string(DTSclockChannel))
				endif
			endif
			if( result eq 0 ) then begin
				if( signal_name eq 0 ) then begin
					result = LINKNLOAD( object, sym_GetDTSinfoR, rtd, type_channel,$
						tch, needDTSlink,$
						real_channel, Shot_number, Sub_Shot_Number,$
						DTSsource, DTShostID, DTSmoduleID, bufDTStrgChannel, $
						CLKSource, CLKhostID, CLKmoduleID, bufDTSclkChannel, $
						DTSuserDefine, DTStimeArraySize, clockSource, $
						bufIntClock, bufSampInterval, bufPreSamp, bufLastCount);
				endif else begin
					result = LINKNLOAD( object, sym_GetDTSinfoR, rtd, type_channel,$
						channelNumber, needDTSlink,$
						real_channel, Shot_number, Sub_Shot_Number,$
						DTSsource, DTShostID, DTSmoduleID, bufDTStrgChannel, $
						CLKSource, CLKhostID, CLKmoduleID, bufDTSclkChannel, $
						DTSuserDefine, DTStimeArraySize, clockSource, $
						bufIntClock, bufSampInterval, bufPreSamp, bufLastCount);
					tch = fix(real_channel)
				endelse
				if( result eq 0 ) then begin
					sDTSsource = string(DTSsource)
					sDTShostID = string(DTShostID)
					sDTSmoduleID = string(DTSmoduleID)
					sCLKsource = string(CLKsource)
					sCLKhostID = string(CLKhostID)
					sCLKmoduleID = string(CLKmoduleID)
					sDTStrgChannel = string(bufDTStrgChannel)
					sDTSclkChannel = string(bufDTSclkChannel)
					if( NOT KEYWORD_SET(silent) ) then begin
						print,'DTS source         = '  ,sDTSsource,		format='(A,A)'
						print,'DTS host ID        = '  ,sDTShostID,		format='(A,A)'
						print,'DTS module ID      = '  ,sDTSmoduleID,	format='(A,A)'
						print,'DTS trigger ch     = '  ,sDTStrgChannel,	format='(A,A)'
						if( sDTSsource ne sCLKsource OR sDTShostID ne sCLKhostID OR sDTSmoduleID ne sCLKmoduleID ) then begin
						print,'CLK source         = '  ,sCLKsource,		format='(A,A)'
						print,'CLK host ID        = '  ,sCLKhostID,		format='(A,A)'
						print,'CLK module ID      = '  ,sCLKmoduleID,	format='(A,A)'
						endif
						print,'DTS clock ch       = '  ,sDTSclkChannel,	format='(A,A)'
						print,'DTS user define    = '  ,DTSuserDefine,	format='(A,I10)'
						print,'Time array size    = '  ,DTStimeArraySize,format='(A,I10)'
					endif
					if( DTStimeArraySize eq 0) then begin
						result = 58
					endif else if(isDouble) then begin
						tmpTimeArray = dblarr(DTStimeArraySize)
						clockCycle = double(0)
						startTiming = double(0)
					endif else begin
						tmpTimeArray = fltarr(DTStimeArraySize)
						clockCycle = float(0)
						startTiming = float(0)
					endelse
					if( DTStimeArraySize ne 0) then begin
					result = LINKNLOAD( object, sym_GetDTSdataR, IndexServer,$
						sDTSsource, sDTShostID, sDTSmoduleID, sDTStrgChannel,$
						sCLKSource, sCLKHostID, sCLKModuleID, sDTSclkChannel,$
						DTSuserDefine, DTStimeArraySize, AShot_Number, ASub_Shot_Number,$
						string(clocksource), string(bufIntClock), string(bufSampInterval), string(bufPreSamp),$
						string(bufLastCount), isSilent, isDouble, tmpTimeArray, clockCycle, startTiming)
					endif
				endif
			endif
;			if( result eq 0 AND DTStimeArraySize eq 0) then begin
;				result = 58
;			endif
			if( result ne 0 ) then begin
				if( NOT KEYWORD_SET(silent) ) then begin
					printRetrieve_tErrorMsg,result,IndexServer,diagName,string(DTShostID)
				endif
				timeArray = 0L
				goto, EXIT_PRO_1
			endif

	
			if( numOfCh eq 1 ) then begin
				timeArray = tmpTimeArray
			endif else begin
				if( loopCnt eq 0 ) then begin
					if(isDouble) then begin
						timeArray = dblarr(DTStimeArraySize, numOfCh)
					endif else begin
						timeArray = fltarr(DTStimeArraySize, numOfCh)
					endelse
					firstTimeSize = DTStimeArraySize
				endif
				if( firstTimeSize ne DTStimeArraySize ) then begin
					if(isnotSilent) then $
						print,'Error! - Time Array size is different from first channel''s.'
					timeArray = 0
					goto, EXIT_PRO_1
				endif
				timeArray(*, loopCnt) = tmpTimeArray
			endelse

			if N_elements(params) NE 0 then begin	;// キーワードパラメータあり ------------------------------
				pset={ PARAMSET, pName:String(' ',format='(A3)'), pValue:String(' ',format='(A3)'), pType:long(0) }
				if ( loopCnt eq 0 ) then begin
					params = Replicate( pset, 13, numOfCh )
				endif

				params(0, loopCnt) = { PARAMSET, 'DTSsource', 		sDTSsource, 		1 }
				params(1, loopCnt) = { PARAMSET, 'DTShostID', 		sDTShostID, 		1 }
				params(2, loopCnt) = { PARAMSET, 'DTSmoduleID', 	sDTSmoduleID, 		1 }
				params(3, loopCnt) = { PARAMSET, 'TriggerCh', 		sDTStrgChannel, 	1 }
				params(4, loopCnt) = { PARAMSET, 'CLKsource', 		sCLKsource, 		1 }
				params(5, loopCnt) = { PARAMSET, 'CLKhostID', 		sCLKhostID, 		1 }
				params(6, loopCnt) = { PARAMSET, 'CLKmoduleID', 	sClkmoduleID, 		1 }
				params(7, loopCnt) = { PARAMSET, 'ClockCh', 		sDTSclkChannel, 	1 }
				params(8, loopCnt) = { PARAMSET, 'ClockSource', 	string(clockSource), 		1 }
				params(9, loopCnt) = { PARAMSET, 'TimeArraySize', 	string(DTStimeArraySize), 	7 }
				if( isDouble ) then begin
					params(10, loopCnt) = { PARAMSET, 'ArrayDataType',		'Double',	 		1 }
					params(11, loopCnt) = { PARAMSET, 'ClockCycle(sec)',	string(clockCycle),	6 }
					params(12, loopCnt) = { PARAMSET, 'StartTiming(sec)',	string(startTiming),6 }
				endif else begin
					params(10, loopCnt) = { PARAMSET, 'ArrayDataType',		'Float',	 		1 }
					params(11, loopCnt) = { PARAMSET, 'ClockCycle(sec)',	string(clockCycle), 5 }
					params(12, loopCnt) = { PARAMSET, 'StartTiming(sec)',	string(startTiming),5 }
				endelse
			endif
			loopCnt = loopCnt+1
		ENDFOR
	ENDFOR
	result = 0
	
EXIT_PRO_1:
	code = result
	if( rtd gt 0 ) then ret = retrieve_close(rtd)
	ret = LINKNLOAD( object, sym_IndexCntl, 0)
END
PRO retrieve_td, shotNumber, subShotNumber, dtsSource, dtsHostID, dtsModuleID,$
	triggerch, clockch, clkEXTorINT, defineClock, sampling, timeArray, code,$
	param=params, silent=silent, double=double,$
	clksource=clkSource, clkhost=clkHostID, clkmodule=clkModuleID,$
	intclk=internalClock, sampInterval=samplingInterval, presamp=presampling,$
	lastCount=lastCount

	if( !version.arch eq 'x86_64' or !version.arch eq 'x64') then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'

	if( (n_params( 0 ) lt 11) or (n_params( 0 ) gt 13) ) then begin
		print, 'Usage:'
		print, '  retrieve_td,shotNumber,subShotNumber,dtsSource,dtsHostID,dtsModuleID,triggerch,clockch,clkEXTorINT,defineClock,sampling,timeArray[,code][,param=keyParams][,/silent][,/double]'
		print, '             [,clksource=clkSource][,clkhost=clkHostID][,clkmodule=clkModuleID]'
;		print, '             [,intclk=internalClock][,sampInterval=samplingInterval][,presamp=presampling][,lastCount=lastCount]'
		print, ' '
		print, 'Input Parameters:'
		print, '  < shotNumber    - Shot number'
		print, '  < subShotNumber - Sub shot number'
		print, '  < dtsSource     - DTS Source (''VME'', ''CAMAC'' etc..)'
		print, '  < dtsHostID     - DTS Host ID (''133.75.175.180'' etc..)'
		print, '  < dtsModuleID   - DTS Module ID (''DMOD0'', ''DMOD1'' etc..)'
		print, '  < triggerch     - DTS Trigger Channel'
		print, '  < clockch       - DTS Clock Channel'
		print, '  < clkEXTorINT   - Clock Source (''Internal'' or ''External'')'
		print, '  < defineClock   - User Define Clock (nsec)'
		print, '  < sampling      - Number of Sampling'
		print, ' '
		print, 'The following explanation is the options of input arguments:'
		print, '  < /silent               - no display without error message'
		print, '  < /double               - return time array in double type'
		print, '  < clksource=clkSource   - If CLK differs from DTS, Clock DTS Source (''VME'', ''CAMAC'' etc..)'
		print, '  < clkhost=clkHostID     - If CLK differs from DTS, Clock Host ID (''133.75.175.180'' etc..)'
		print, '  < clkmodule=clkModuleID - If CLK differs from DTS, Clock Module ID (''DMOD0'', ''DMOD1'' etc..)'
;		print, '  < intclk=internalClock  - Internal Clock Speed'
;		print, '  < sampInterval=samplingInterval - Sampling Interval'
;		print, '  < presamp=preSampling   - numbers of preSampling'
;		print, '  < lastcount=lastCount   - count of last data'
		print, ' '
		print, 'Output Parameters:'
		print, '  > timeArray       - Time array'
		print, '  > code            - result code(option)'
		print, '  > param=keyParams - Returned parameter (option)'
		print, '                      (keyParams must be pre-defined, i.e. keyParams=1)'
		print, ' '
		code=-1
		retall
	endif

	isSetClk = 0
	IndexServer = getenv('INDEXSERVERNAME')
	AShot_Number = long( shotNumber )
	ASub_Shot_Number= fix ( subShotNumber )

	DTSuserDefine = long(defineclock)
	DTStimeArraySize = long(sampling)

	strDTSsource = string(dtsSource)
	strDTShostID = string(dtsHostID)
	strDTSmoduleID = string(dtsModuleID)
	DTStriggerChannel = string(triggerch)
	DTSclockChannel = string(clockch)

	strClockSource = string(clkEXTorINT)

	if( KEYWORD_SET(clkSource)) then begin
		strCLKsource = string(clkSource)
		isSetClk = 1
	endif else begin
		strCLKsource = strDTSsource
	endelse
	if( KEYWORD_SET(clkHostID)) then begin
		strCLKhostID = string(clkHostID)
		isSetClk = 1
	endif else begin
		strCLKhostID = strDTShostID
	endelse
	if( KEYWORD_SET(clkModuleID)) then begin
		strCLKmoduleID = string(clkModuleID)
		isSetClk = 1
	endif else begin
		strCLKmoduleID = strDTSmoduleID
	endelse

	if( KEYWORD_SET(internalClock)) then begin
		strIntClock = string(internalClock)
	endif else begin
		strIntClock = string(defineclock)+'ns'
	endelse
			
	if( KEYWORD_SET(samplingInterval)) then begin
		strSampInterval = string(samplingInterval)
	endif else begin
		strSampInterval = '1'
	endelse

	if( KEYWORD_SET(preSampling)) then begin
		strPreSamp = string(preSampling)
	endif else begin
		strPreSamp = '0'
	endelse

	if( KEYWORD_SET(lastCount)) then begin
		strLastCount =	string(lastCount)
	endif else begin
		strLastCount = '0'
	endelse

	if( NOT KEYWORD_SET(silent)) then begin
		print,'---DTS Infomation---'
		print,'Index Server Name  = ' ,string(IndexServer),format='(A,A)'
		print,'Shot Number        = ' ,AShot_Number       ,format='(A,I10)'
		print,'Sub Shot Number    = ' ,ASub_Shot_Number   ,format='(A,I10)'

		print,'DTS source         = ' ,strDTSsource       ,format='(A,A)'
		print,'DTS host ID        = ' ,strDTShostID       ,format='(A,A)'
		print,'DTS module ID      = ' ,strDTSmoduleID     ,format='(A,A)'
		print,'DTS trigger ch     = ' ,DTStriggerChannel  ,format='(A,A)'
		if( isSetClk ) then begin
		print,'DTS clock source   = ' ,strCLKsource       ,format='(A,A)'
		print,'DTS clock host ID  = ' ,strCLKhostID       ,format='(A,A)'
		print,'DTS clock module ID= ' ,strCLKmoduleID     ,format='(A,A)'
		endif
		print,'DTS clock ch       = ' ,DTSclockChannel    ,format='(A,A)'
		print,'DTS user define    = ' ,DTSuserDefine      ,format='(A,I10)'
		print,'Time array size    = ' ,DTStimeArraySize   ,format='(A,I10)'
	endif

	if( NOT KEYWORD_SET(silent)) then begin
		isSilent=fix(0)
	endif else begin
		isSilent=fix(1)
	endelse

	if( DTStimeArraySize eq 0) then begin
		result = 58
		timeArray = 0L
		code=result
		return
	endif else if( NOT KEYWORD_SET(double)) then begin
		isDouble = long(0)
		timeArray = fltarr(DTStimeArraySize)
		clockCycle = float(0)
		startTiming = float(0)
	endif else begin
		isDouble = long(1)
		timeArray = dblarr(DTStimeArraySize)
		clockCycle = double(0)
		startTiming = double(0)
	endelse
	sym_GetDTSdata = 'PvwRetrieveGetDTSdatax2'

	result = LINKNLOAD( object, sym_GetDTSdata, IndexServer,$
			strDTSsource, strDTShostID, strDTSmoduleID, DTStriggerChannel,$
			strCLKSource, strCLKHostID, strCLKModuleID, DTSclockChannel,$
			DTSuserDefine, DTStimeArraySize, AShot_Number, ASub_Shot_Number,$
			strClocksource, strIntClock, strSampInterval, strPreSamp,$
			strLastCount, isSilent, isDouble, timeArray, clockCycle, startTiming)
			
	if( result ne 0 ) then begin
		printRetrieve_tErrorMsg,result,IndexServer,'',DTShostID
		timeArray = 0L
		code=result
		return
	endif

	if N_elements(params) NE 0 then begin	;// キーワードパラメータあり ------------------------------
		pset={ PARAMSET, pName:String(' ',format='(A3)'), pValue:String(' ',format='(A3)'), pType:long(0) }
		if( isSetClk ) then begin
			pnum = 13
		endif else begin
			pnum = 10
		endelse
		params = Replicate( pset, pnum )

		params(0)		= { PARAMSET, 'DTSsource', 		strDTSsource, 		1 }
		params(1)		= { PARAMSET, 'DTShostID', 		strDTShostID, 		1 }
		params(2)		= { PARAMSET, 'DTSmoduleID', 	strDTSmoduleID, 	1 }
		params(3)		= { PARAMSET, 'TriggerCh', 		DTStriggerChannel, 	4 }
		if( isSetClk ) then begin
			params(4)	= { PARAMSET, 'CLKsource', 		strCLKsource, 		1 }
			params(5)	= { PARAMSET, 'CLKhostID', 		strCLKhostID, 		1 }
			params(6)	= { PARAMSET, 'CLKmoduleID', 	strCLKmoduleID,		1 }
		endif
		params(pnum-6)	= { PARAMSET, 'ClockCh', 		DTSclockChannel, 	4 }
		params(pnum-5)	= { PARAMSET, 'ClockSource', 	strClockSource, 	1 }
		params(pnum-4)	= { PARAMSET, 'TimeArraySize',	string(DTStimeArraySize), 	7 }
		if( KEYWORD_SET(double)) then begin
			params(pnum-3) = { PARAMSET, 'ArrayDataType',	'Double',	 			1 }
			params(pnum-2) = { PARAMSET, 'ClockCycle(sec)',	string(clockCycle), 	6 }
			params(pnum-1) = { PARAMSET, 'StartTiming(sec)',	string(startTiming),6 }
		endif else begin
			params(pnum-3) = { PARAMSET, 'ArrayDataType',	'Float',	 			1 }
			params(pnum-2) = { PARAMSET, 'ClockCycle(sec)',	string(clockCycle), 	5 }
			params(pnum-1) = { PARAMSET, 'StartTiming(sec)',	string(startTiming),5 }
		endelse
	endif
END
PRO retrieve_dts,dtsName,shotNumber,subShotNumber,channelNumber,timeArray,code,param=params,silent=silent,double=double

	if( !version.arch eq 'x86_64' or !version.arch eq 'x64') then object = !Retrieve + '/bin64/retrieve.dll' $
	else object = !Retrieve + '/bin/retrieve.dll'

	sym_GetDTSParameters = 'PvwRetrieveGetDTSParameters'
	sym_GetDTSParametersCount = 'PvwRetrieveGetDTSParametersCount'

	code=0
	if( (n_params( 0 ) lt 5) or (n_params( 0 ) gt 7) ) then begin
		print, 'Usage:'
		print, '  retrieve_dts,dtsHost,shotNumber,subShotNumber,channelNumber,timeArray[,param=keyParams][,/silent]'
		print, ' '
		print, 'Input Parameters:'
		print, '  < dtsHost       - dts name (''VME01'',''VME01:DMOD1'',''133.75.175.100''.., etc.)'
		print, '  < shotNumber    - Shot number'
		print, '  < subShotNumber - Sub shot number'
		print, '  < channelNumber - Channel number'
		print, '  < /silent       - no display without error message'
		print, ' '
		print, 'Output Parameters:'
		print, '  > timeArray       - Time array (useless for this procedure)'
		print, '  > param=keyParams - Returned parameter (option)'
		print, '                      (keyParams must be pre-defined, i.e. keyParams=1)'
		print, ' '
		code=-1
		retall
	endif

	chkstr = strsplit(dtsName, ':')
	schkstr = size(chkstr)
	host_name= 'NONAME'
	mod_name = 'NONAME'	;// 無効な指定の場合は、DLL側でDMOD0またはDMODSS0として処理
	if (schkstr(1) eq 2) then begin
		if(strlen(chkstr(0)) ne 0) then begin
			host_name = chkstr(0)
		endif
		if(strlen(chkstr(1)) ne 0) then begin
			mod_name = chkstr(1)
		endif
	endif else begin
		if(strlen(chkstr(0)) ne 0) then begin
			host_name = chkstr(0)
		endif
	endelse

	Server = bytarr(32)
	IndexServer = getenv('INDEXSERVERNAME')
	AShot_Number = long( shotNumber )
	ASub_Shot_Number= fix ( subShotNumber )

	if( IndexServer eq '' ) then begin
		setenv,'INDEXSERVERNAME=DASINDEX'
		IndexServer = getenv('INDEXSERVERNAME')
	endif

	;//	channel decode
	chs_cnt = channel_decode( channelNumber, st_recs, en_recs)
	;// siganl_name error
	if( chs_cnt le 0 ) then begin
		if( NOT KEYWORD_SET(silent)) then $
			print,'<Error: Illegal channel number!>'
		code = -1;
		return
	endif
	sch = st_recs(0)
	ech = en_recs(0)
	for i=0, chs_cnt-1 do begin
		if( en_recs(i) eq 0 ) then begin
			sch=1
			ech=0
			goto, BRK_LOOP1
		endif
		if( sch gt st_recs(i) ) then begin
		 	sch = st_recs(i)
		endif
		if( ech lt en_recs(i) ) then begin
		 	ech = en_recs(i)
		endif
	endfor
	
BRK_LOOP1:
	sch=long(sch);
	ech=long(ech);
	sym_IndexCntl = 'PvwIndexNoClosing'
	res = LINKNLOAD( object, sym_IndexCntl, 1L);
;//	パラメータの配列数を取得 (指定したチャネル範囲内で最大の数を取得する)
;//	※ DMODSS でトリガ用かクロック用かでパラメータ数が違うため
	paramCount = fix(0)
	result = LINKNLOAD( object, sym_GetDTSParametersCount, IndexServer,$
		host_name, mod_name, AShot_Number, ASub_Shot_Number, paramCount, sch, ech)

	if( result ne 0 ) then begin
		if( NOT KEYWORD_SET(silent)) then $
			printRetrieve_tErrorMsg,result,IndexServer,'',host_name
		timeArray = 0L
		goto, EXIT_PRO_1
	endif

	numOfCh = 0
	for i=0, chs_cnt-1 do begin
		if( st_recs(i) eq 0 AND en_recs(i) eq 0 ) then begin
			st_recs(i)=1
			en_recs(i)=ech
		endif
		if( en_recs(i) gt ech ) OR ( st_recs(i) gt ech ) OR $
		  ( en_recs(i) le 0 ) OR ( st_recs(i) le 0 ) then begin
			numOfCh = 0
		  	goto, BRK_FOR_1
		endif
		if( st_recs(i) le en_recs(i) ) then begin
		 	numOfCh = numOfCh + ( en_recs(i) - st_recs(i) + 1)
		endif else begin
			numOfCh = numOfCh + ( st_recs(i) - en_recs(i) + 1)
		endelse
	endfor
BRK_FOR_1:
	if(numOfCh le 0) then begin
		if( NOT KEYWORD_SET(silent)) then $
			print,'<Error: Illegal channel number!>'
		result = -1
		goto, EXIT_PRO_1
	endif

	if( NOT KEYWORD_SET(silent)) then begin
		print,'---DTS Infomation---'
		print,'Index Server Name  = '  ,string(IndexServer),format='(A,A)'
		print,'Shot Number        = '  ,AShot_Number       ,format='(A,I10)'
		print,'Sub Shot Number    = '  ,ASub_Shot_Number   ,format='(A,I10)'

		print,'DTS source         = '  ,host_name  ,format='(A,A)'
		print,'Channel Range      = [ '  ,sch, '  -  ',ech,' ]', format='(A,I3,A,I3,A)'
	endif
	timeArray = 0

	loopCnt = 0
	FOR x=0,(chs_cnt-1) DO BEGIN
	step = 1
	if( st_recs(x) gt en_recs(x) ) then step = -1
	FOR tmp_chno=st_recs(x), en_recs(x), step DO BEGIN
		chno=long(tmp_chno)
		if( loopCnt eq 0) then begin
			;//	最初のチャネルの場合、パラメータ配列作成
			pset={ PARAMSET, pName:String(' ',format='(A3)'), pValue:String(' ',format='(A3)'), pType:long(0) }
			psetArray = Replicate( pset, paramCount, numOfCh )
		endif

		pNameBuf = strarr( paramCount )	;// for parameter name
		pValueBuf = strarr( paramCount )	;// for parameter value
		pTypeBuf = lonarr( paramCount )	;// for parameter data type

		for pc=0,paramCount-1 do begin
			pNameBuf(pc) =  string( replicate(32b, 64) );	// 64 character
			pValueBuf(pc) = string( replicate(32b,128) );	// 128 character
			pTypeBuf(pc) = 0L
		endfor

		result = LINKNLOAD( object,sym_GetDTSParameters,IndexServer, host_name, mod_name, AShot_Number, ASub_Shot_Number,chno,paramCount,pNameBuf,pValueBuf,pTypeBuf)

		if( result ne 0 ) then begin
			if( NOT KEYWORD_SET(silent)) then begin
				print,'Error from DLL( ',sym_GetDTSParameters,' )! ',result,' : ',result
				printRetrieve_tErrorMsg,result,IndexServer,'',host_name
			endif
			goto, EXIT_PRO_1
		endif

		for pc=0,paramCount-1 do begin
			psetArray(pc,loopCnt).pName = pNameBuf(pc)
			psetArray(pc,loopCnt).pValue = pValueBuf(pc)
			psetArray(pc,loopCnt).pType = pTypeBuf(pc)
		endfor
		loopCnt = loopCnt+1
	ENDFOR
	ENDFOR
	if N_elements(params) NE 0 then params = psetArray
	result = 0
EXIT_PRO_1:
	code = result
	res = LINKNLOAD( object, sym_IndexCntl, 0L);
	return
END
